//@charset "utf-8";
(function($) {
    $.fn.tableSortable = function(options) {
        options = options || {};
        var hasIndex = options.hasIndex;
        var $table   = this;
        
        this.find('th').each(function(column) {
            var $header = $(this);
            var findSortKey;
            if ($header.hasClass('sort-alpha')) {
                findSortKey = function($cell) {
                    return $cell.children('input').val() || $cell.text();
                };
            } else if ($header.hasClass('sort-numeric')) {
                findSortKey = function($cell) {
                    var key = $cell.text().replace(/^[^\d.]*/, '');
                    key = parseFloat(key);
                    return isNaN(key) ? 0 : key;
                };
            }
            if (findSortKey) {
                $header.addClass('clickable').hover(function() {
                    $header.addClass('hover');
                }, function() {
                    $header.removeClass('hover');
                }).click(function(event, same) {
                    var sortDirection = 1;
                    if (same) {
                        if ($header.hasClass('sorted-desc')) {
                            sortDirection = -1;
                        } else {
                            sortDirection =  1;
                        }
                    } else {
                        if ($header.hasClass('sorted-asc')) {
                            sortDirection = -1;
                        }
                    }
                    var rows = $table.find('tbody > tr').get();
                    $.each(rows, function(index, row) {
                        var $cell = $(row).children('td').eq(column);
                        row.sortKey = findSortKey($cell);
                    });
                    rows.sort(function(a, b) {
                        if (typeof a.sortKey == 'string' && typeof b.sortkey == 'string') {
                            if (a.sortKey.localeCompare(b.sortKey) < 0) return -sortDirection;
                            if (a.sortKey.localeCompare(b.sortKey) > 0) return  sortDirection;
                        } else {
                            if (a.sortKey < b.sortKey) return -sortDirection;
                            if (a.sortKey > b.sortKey) return  sortDirection;
                        }
                        return 0;
                    });
                    $.each(rows, function(index, row) {
                        if (hasIndex) {
                            if ($.browser.msie) {
                                row.childNodes[0].innerHTML = index + 1;
                            } else {
                                row.childNodes[1].innerHTML = index + 1;
                            }
                        }
                        $table.children('tbody').append(row);
                        row.sortKey = null;
                    });
                    $table.find('th').removeClass('sorted-asc')
                                     .removeClass('sorted-desc');
                    if (sortDirection == 1) {
                        $header.addClass('sorted-asc');
                    } else {
                        $header.addClass('sorted-desc');
                    }
                    $table.find('tbody > tr > td').removeClass('sorted')
                          .filter(':nth-child(' + (column + 1) + ')').addClass('sorted');
                });
            }
        });
    }
}(jQuery));
