//@charset "utf-8"

/**
 * 客户端实时行情数据	v1.0
 * 
 * @author	余庆<yuqing@myhexin.com>
 * @create	2015-10-16
 * @dependence	不依赖其他js框架
 * @notic	须在同花顺软件的环境下运行
 */

function ComHqData() {
	this.stocks = ['600000'];
	this.quote = ['new', 'ZHANGDIEFU'];
	this.periodv = 'now';
	this.callback = 'callback';
	this.pushcallback = false;
	this._init.apply(this, arguments);
}

ComHqData.prototype = {
	create: function () {
		this._requestHqData();
		if (this.pushcallback) {
			this._listenPageSwitch();
			this._registerPush();
		}
	},
	_init: function (options) {

		//股票
		this.stocks = options.stocks || this.stocks;
		
		//行情数据
		this.quote = options.quote || this.quote;
		
		//周期
		this.periodv = options.period || this.periodv;

		//行情request回调函数
		this.callback = options.callback || '';

		this.pushcallback = options.pushcallback;
		
		//行情数据
		this.hqData = {};

		//客户端Quote对象
		this.clientQuote = external.createObject("Quote");
	},
	//获取行情数据
	_requestHqData: function () {
		var thsQuote = this.clientQuote,
			paramStock = this.stocks,
			paramQuote = this.quote,
			stocks = paramStock.join(','),
			quoteStr = paramQuote.join(','),
			periodStr = this.periodv,
			hqRenderCallback = this.callback,
			_this = this;

		var curVersion = this._getClientVersion();
		//客户端新增接口getData2,E028.60.30.0002版本开始增加该接口
		var reqObj = {};
		if (this._versionCompare(curVersion, '8.60.30.0002')) {
			reqObj = {
				code: stocks,
				type: quoteStr,
				period: periodStr,
				onready: function() {
					var codeData = {};
					for (var k in _this.stocks) {
						var curCode = _this.stocks[k];
						var param = {code : curCode};
						codeData[curCode] = {};
						for (var i in _this.quote) {
							param.type = _this.quote[i];
							var tmpObj = thsQuote.getData(param);
							try {
								tmpObj = eval('(' + tmpObj + ')');
							} catch(e) {
								return;
							}
							var itemValue = tmpObj[curCode][param.type];
							codeData[curCode][param.type] = itemValue;
						}
					}

					_this._setData(codeData, hqRenderCallback);
				}
			};
		} else {
			reqObj = {
				code: paramStock,
				type: paramQuote,
				period: 'now',
				onready: function() {
					var param = {
						code: paramStock,
						mode: 'after',
						type: paramQuote,
						period: periodStr
					};
					var codeData = thsQuote.getData2(param);
					codeData = eval('(' + codeData + ')');
					
					_this._setData(codeData, hqRenderCallback);
				}
			};
		}

		thsQuote.request(reqObj);
	},
	
	_setData: function(obj, callback) {
		if (callback) {
			callback(obj);
		}
	},
	
	_registerPush: function() {
		var _this = this;
		var stocks = _this.stocks.join(',');
		var items = ['new', 'vol', 'money'];
		var thsQuote = _this.clientQuote;
		thsQuote.registerPush({
			code: stocks,
			onready: function (data) {
				var codeData = {};
				for (var k in _this.stocks) {
					var curCode = _this.stocks[k];
					var param = {code : curCode};
					codeData[curCode] = {};
					for (var i in items) {
						param.type = items[i];
						var tmpObj = thsQuote.getData(param);
						try {
							tmpObj = eval('(' + tmpObj + ')');
						} catch(e) {
							return;
						}
						codeData[curCode][param.type] = tmpObj[curCode][param.type];
					}
				}

				_this._setData(codeData, _this.pushcallback);
			}
		});
	},
	
	_listenPageSwitch: function() {
		var _this = this;
		external.registerEvent({onshow : function(inPage){
			if(inPage){
				
			}else{
				_this._unregisterPush();
			}
		}});
	},
	
	_unregisterPush: function() {
		var _this = this;
		var thsQuote = _this.clientQuote;
		thsQuote.unregisterPush();
	},
	
	_getClientVersion: function () {
		try {
			var thsUtil = external.createObject('Util');
			var ret = thsUtil.getHxVer();
			//return ret;
			var versionArr = ret.split('.');
			ret = versionArr[0].substr(3) + "." + versionArr[1] + "." + versionArr[2];
			if (typeof(versionArr[3]) != 'undefined') {
				ret += "." + versionArr[3];
			}
			return ret;
		} catch (e) {
			return null;
		}
	},
	
	_versionCompare: function(a, b){
		var clientVer = parseInt(a.replace(/\./g, ""));
		var funciontVer = parseInt(b.replace(/\./g, ""));
		var flag = false;
		if (clientVer < funciontVer) {
			flag = true;
		}
		return flag;
	}
};
