/**
 * 图表参数UI
 * @author: 卢海宁<luhaining@myhexin.com>
 * @create: 2014-05-08
 */
var Chatargs = Panel.extend({
	// 期权列表Panel对象
	optionsObj: null,
	// 坐标参数Panel对象
	coordargsObj: null,
	// 标的价格选择器
	nowCls: null,
	// 价格Spinner选择器
	priinputCls: null,
	// 波动率Spinner选择器
	volinputCls: null,
	// 无风险利率Spinner选择器
	ratinputCls: null,
	// 价格Slider选择器
	prisliderCls: null,
	// 波动率Slider选择器
	volsliderCls: null,
	// 无风险利率Slider选择器
	ratsliderCls: null,
	// 日期选择器
	dateCls: null,
	// 组合选择器
	portfolioCls: null,
	// 价格
	price: null,
	// 波动率
	volatility: null,
	
	_render: function(){
		// alert('addOption_render')
		$('#options').empty();
		var $base = $(this.baseCls);
		var date = new Date();
		$base.find(this.dateCls).val([date.getFullYear(), date.getMonth()+1, date.getDate()].join('/'));
		
		// 初始化
		var now = this.price;
		//alert(etftype);
		if (etftype == 1){
			now = parseFloat(this.price, 10).toFixed(3);
			//alert(now);
			$base.find(this.priinputCls).spinner({
			min: 0.001,
			max: 999.999,
			step: 0.001,
			numberFormat: 'n3'
		}).attr('ovalue', now).spinner('value', now);
		$base.find(this.prisliderCls).slider({
			min: 1,
			max: 999999
		}).slider('value', now*1000);
		} else{
			now = parseFloat(this.price, 10).toFixed(2);
			$base.find(this.priinputCls).spinner({
			min: 0.01,
			max: 999.99,
			step: 0.01,
			numberFormat: 'n'
		}).attr('ovalue', now).spinner('value', now);
		$base.find(this.prisliderCls).slider({
			min: 1,
			max: 99999
		}).slider('value', now*100);
		}
		/*$base.find(this.priinputCls).spinner({
			min: 0.01,
			max: 999.99,
			step: 0.01,
			numberFormat: 'n'
		}).attr('ovalue', now).spinner('value', now); */
		// 初始化
		var vol = this.volatility;
		$base.find(this.volinputCls).spinner({
			min: 0.001,
			max: 4.000,
			step: 0.001
		//	numberFormat: 'n'
		}).attr('ovalue', vol).spinner('value', vol);
		$base.find(this.volsliderCls).slider({
			min: 1,
			max: 4000
		}).slider('value', vol*1000);
		// 初始化
		var rat = 0.06;
		$base.find(this.ratinputCls).spinner({
			min: 0,
			max: 0.99,
			step: 0.01,
			numberFormat: 'n'
		}).attr('ovalue', rat).spinner('value', rat);
		$base.find(this.ratsliderCls).slider({
			min: 0,
			max: 99
		}).slider('value', rat*100);
		
		//this.optionsObj.calcOption('all');
		var num = $('#options').find('tr').length;
		if(num == 0){
			this.optionsObj.addOption(1);
		}
	},
	
	_bindEvent: function(){
		var me = this;
		var $base = $(this.baseCls);
		$base.find(this.prisliderCls).slider( "option", {
			change: function(event, ui){
				//log.log(['#prislider Change!', (ui.value/100).toFixed(2)]);
				$(me.priinputCls).blur();
			},
			slide: function(event, ui){
				if (etftype == 1){
				var val = (ui.value/1000).toFixed(3);
				var $pri = $(me.priinputCls);
				$pri.spinner('value', val);
				} else {
				var val = (ui.value/100).toFixed(2);
				var $pri = $(me.priinputCls);
				$pri.spinner('value', val);
				}
			}
		});
		$base.find(this.volsliderCls).slider( "option", {
			change: function(event, ui){
				//log.log(['#volslider Change!', (ui.value/100).toFixed(2)]);
				$(me.volinputCls).blur();
			},
			slide: function(event, ui){
				var val = (ui.value/1000).toFixed(3);
				var $vol = $(me.volinputCls);
				$vol.spinner('value', val);
			}
		});
		$base.find(this.ratsliderCls).slider( "option", {
			change: function(event, ui){
				//log.log(['#ratslider Change!', (ui.value/100).toFixed(2)]);
				$(me.ratinputCls).blur();
			},
			slide: function(event, ui){
				var val = (ui.value/100).toFixed(2);
				var $rat = $(me.ratinputCls);
				$rat.spinner('value', val);
			}
		});
		// 保证价格2位小数 0.01 - 999.99
		$base.find(this.priinputCls).on('blur', function(e){
			if(etftype == 0){
				var oval = parseFloat(this.getAttribute('ovalue'), 10).toFixed(2);
				var val = parseFloat(this.value, 10).toFixed(2);
				if (this.value == ''){
				this.value = oval;
			    }else  if(isNaN(this.value)){
					this.value = oval;
					//return;
				}else if(val < 0.01){
					this.value = oval;
				}else if(val > 999.99){
					this.value = oval;
				}else{
					this.value = val;
				}
				val = this.value;
				if(val == oval){
					return;
				}else{
					//log.log(['#priinput Change!', oval, val]);
					this.setAttribute('ovalue', val);
					$(me.prisliderCls).slider('value', val*100);
					// alert('2---------'+val)
					me.coordargsObj.setPrice(val);
					$(me.nowCls).val(val).attr('ovalue', val);
					me.optionsObj.calcOption('all');
				}
			}else{
				// alert('a')
				var oval = parseFloat(this.getAttribute('ovalue'), 10).toFixed(3);
				var val = parseFloat(this.value, 10).toFixed(3);
				  if (this.value == ''){
				this.value = oval;
			    }else  if(isNaN(this.value)){
					this.value = oval;
					//return;
				}else if(val < 0.001){
					this.value = oval;
				}else if(val > 999.999){
					this.value = oval;
				}else{
					this.value = val;
				}
				// alert(oval+'-----------'+val+'-----------'+this.value)
				val = this.value;
				if(val == oval){
					return;
				}else{
					//log.log(['#priinput Change!', oval, val]);
					this.setAttribute('ovalue', val);
					$(me.prisliderCls).slider('value', val*1000);
					// alert('3-----------'+val)
					me.coordargsObj.setPrice(val);
					$(me.nowCls).val(val).attr('ovalue', val);
					me.optionsObj.calcOption('all');
				}
				
			}
		});
		// 保证波动率3位小数 0.000 - 4.000
		$base.find(this.volinputCls).on('blur', function(e){
			var oval = parseFloat(this.getAttribute('ovalue'), 10).toFixed(3);
			var val = parseFloat(this.value, 10).toFixed(3);
			if (this.value == ''){
				this.value = oval;
			}else if(isNaN(this.value)){
				this.value = oval;
				//return;
			}else if(val < 0.001){
				this.value = oval;
			}else if(val > 4){
				this.value = oval;
			}else{
				this.value = val;
			}
			val = this.value;
			if(val == oval){
				return;
			}else{
				//log.log(['#volinput Change!', oval, val]);
				this.setAttribute('ovalue', val);
				$(me.volsliderCls).slider('value', val*1000);
				//me.chatargsObj.attr('ovalue', val).spinner('value', val);
				me.coordargsObj.setVolatility(val);
				me.optionsObj.calcOption('all');
			}
		});
		// 保证无风险利率2位小数 0.01 - 999.9999
		$base.find(this.ratinputCls).on('blur', function(e){
			var oval = parseFloat(this.getAttribute('ovalue'), 10).toFixed(2);
			var val = parseFloat(this.value, 10).toFixed(2);
			if (this.value == ''){
				this.value = oval;
			}else if(isNaN(this.value)){
				this.value = oval;
				//return;
			// }else if(val < 0.01){//20150202-最小值改为0
			}else if(val < 0){
				this.value = oval;
			}else if(val > 0.99){
				this.value = oval;
			}else{
				this.value = val;
			}
			val = this.value;
			if(val == oval){
				return;
			}else{
				//log.log(['#ratinput Change!', oval, val]);
				this.setAttribute('ovalue', val);
				$(me.ratsliderCls).slider('value', val*100);
				me.coordargsObj.setRate(val);
				me.optionsObj.calcOption('all');
			}
		});
		// 切换选中组合checkbox
		$base.on('change', this.portfolioCls, function(e) {
			me.optionsObj.calcOption('all');
		});
	},
	/*
	 * 设置价格，为了Chatargs提供的方法
	 */
	setPrice: function(val){
		var $base = $(this.baseCls);
		$base.find(this.priinputCls).attr('ovalue', val).spinner('value', val);
		$base.find(this.prisliderCls).slider('value', val*100);
	},
	/*
	 * 重置
	 */
	reset: function(){
		// alert('addOption_reset')
		this.optionsObj._reseting = true;
		var $base = $(this.baseCls);
		// 重置价格
		var now = this.price;
		$base.find(this.priinputCls).attr('ovalue', now).spinner('value', now);
		if (etftype == 0){
		$base.find(this.prisliderCls).slider('value', now*100);
		} else {
			$base.find(this.prisliderCls).slider('value', now*1000);
		}
		// 重置波动率
		var vol = this.volatility;
		$base.find(this.volinputCls).attr('ovalue', vol).spinner('value', vol);
		$base.find(this.volsliderCls).slider('value', vol*1000);
		// 重置无风险利率
		var rat = 0.06;
		$base.find(this.ratinputCls).attr('ovalue', rat).spinner('value', rat);
		$base.find(this.ratsliderCls).slider('value', rat*100);
		this.optionsObj._reseting = false;
		
		var num = $('#options').find('tr').length;
		if(num == 0){
			this.optionsObj.addOption(1);
		}
	}
});