/**
 * 坐标参数UI
 * @author: 卢海宁<luhaining@myhexin.com>
 * @create: 2014-05-08
 */
var Coordargs = Panel.extend({
	// 期权列表Panel对象
	optionsObj: null,
	// 横坐标选择器
	xaxisCls: null,
	// 纵坐标选择器
	yaxisCls: null,
	// 股票价格选择器
	priceCls: null,
	// 波动率选择器
	volCls: null,
	// 日期选择器
	dateCls: null,
	// 无风险利率选择器
	rateCls: null,
	// 价格
	price: null,
	// 波动率
	volatility: null,
	// 无风险利率（默认0.06）
	rate: 0.06,
	
	_render: function(){
		var $base = $(this.baseCls);
		$base.find(this.priceCls).html('<span style="visibility: hidden;">' + this.price + '</span>');
		$base.find(this.volCls).html('<span style="visibility: visible;">' + this.volatility + '</span>');
		var date = new Date();
		$base.find(this.dateCls).html('<span style="visibility: visible;">' + [date.getFullYear(), date.getMonth()+1, date.getDate()].join('/') + '</span>');
	},
	
	_bindEvent: function(){
		var me = this;
		// 切换纵坐标
		$(this.baseCls).on('change', this.yaxisCls, function(e) {
			var $el = $(this);
			var $tr = $el.parents('tr');
			var $tbody = $el.parents('tbody');
			var axis = [$el.val(), $tr.find(me.xaxisCls).val()].join('_');
			if($tbody.find('tr[axis="' + axis + '"]').length == 0){
				$tr.attr('axis', axis);
				me.optionsObj.calcOption();
			}else{
				$el.val($tr.attr('axis').substr(0, 1));
			}
		});
		
		// 切换横坐标
		$(this.baseCls).on('change', this.xaxisCls, function(e) {
			var $el = $(this);
			var $tr = $el.parents('tr');
			var $tbody = $el.parents('tbody');
			var axis = [$tr.find(me.yaxisCls).val(), $el.val()].join('_');
			if($tbody.find('tr[axis="' + axis + '"]').length == 0){
				$tr.attr('axis', axis);
				$tr.find('span').css('visibility', 'visible');
				$tr.find('span:eq(' + $el.val() + ')').css('visibility', 'hidden');
				me.optionsObj.calcOption();
			}else{
				axis = $tr.attr('axis');
				$el.val(axis.substr(axis.length - 1));
			}
			
			var $chart = $('.chatargs');
			// var $opts = $base.find(this.optionsCls).find('tr');
			var volspinner = $chart.find('#volinput').spinner();
			var prispinner = $chart.find('#priinput').spinner();
			var volslider = $chart.find('#volslider').slider();
			var prislider = $chart.find('#prislider').slider();
			var val = $('.coordargs').find('.xaxis:eq(0)').val();
			var oval = $('.coordargs').find('.xaxis:eq(1)').val();
			if (val == 2 && oval == 2){
				volspinner.spinner('enable');
				volslider.slider('enable');
				prispinner.spinner('enable');
				prislider.slider('enable');
			} else if(val ==0 && oval ==0){
			  	     prispinner.spinner('disable');
				     prislider.slider('disable');
				     volspinner.spinner('enable');
					 volslider.slider('enable');
			} else if (val == 1 && oval == 1){
				      prispinner.spinner('enable');
					   prislider.slider('enable');
				     volspinner.spinner('disable');
					 volslider.slider('disable');
			} else if ((val == 0 || val == 1) && (oval == 0 || oval == 1)){
				     prispinner.spinner('disable');
					 prislider.slider('disable');
				     volspinner.spinner('disable');
					 volslider.slider('disable');
			} else if (val == 0 || oval ==0){
				     prispinner.spinner('disable');
					  prislider.slider('disable');
				     volspinner.spinner('enable');
					 volslider.slider('enable');
			} else if(val == 1 || oval ==1){
				     volspinner.spinner('disable');
				     volslider.slider('disable');
				     prispinner.spinner('enable');
					 prislider.slider('enable');
				    
			}
				
			
		});
	},
	/*
	 * 重置
	 */
	reset: function(){
		this.setPrice(this.price);
		this.setVolatility(this.volatility);
		this.setRate(this.rate);
	},
	/*
	 * 获取价格
	 */
	getPrice: function(){
		var $base = $(this.baseCls);
		return $base.find(this.priceCls).eq(0).text();
	},
	/*
	 * 设置价格，为了Chatargs提供的方法
	 */
	setPrice: function(val){
		var $base = $(this.baseCls);
		$base.find(this.priceCls).find('span').text(val);
	},
	/*
	 * 获取波动率
	 */
	getVolatility: function(){
		var $base = $(this.baseCls);
		return $base.find(this.volCls).eq(0).text();
	},
	/*
	 * 设置波动率，为了Chatargs提供的方法
	 */
	setVolatility: function(val){
		var $base = $(this.baseCls);
		$base.find(this.volCls).find('span').text(val);
	},
	/*
	 * 获取无风险利率
	 */
	getRate: function(){
		var $base = $(this.baseCls);
		return $base.find(this.rateCls).eq(0).text();
	},
	/*
	 * 设置无风险利率，为了Chatargs提供的方法
	 */
	setRate: function(val){
		var $base = $(this.baseCls);
		$base.find(this.rateCls).find('span').text(val);
	}
});