/**
 * 布局类
 * @author: 卢海宁<luhaining@myhexin.com>
 * @create: 2013-11-18
 */
var Layout = Panel.extend({
	/*
	 * 配置
	 * Array -> 
	 *  Object -> 
	 *   selector String 选择器
	 *   fix Number 修正值（为了修正边框等等）
	 */
	config: null,
	// 浏览器滚动条宽度
	_scrollBarSize: null,
	// 是否正在resize
	_resizeing: false,
	// 是否正在resize
	_resizeing4IE6: false,
	// UI容器
	appCls: '.app',
	// UI标题
	titleCls: '.title',
	// UI头部
	headCls: '.head',
	// UI躯干
	bodyCls: '.body',
	// UI底部
	footCls: '.foot',
	// UI数据表格
	tableCls: '.boxtable',
	
	_initialize: function(cfg){
		// 计算滚动条宽度
		var tmpDiv = document.createElement('div');
		tmpDiv.style.overflow= "scroll";
		tmpDiv.style.position = 'absolute';
		tmpDiv.style.left = '-1000px';
		tmpDiv.style.top = '-1000px';
		tmpDiv.style.width = "100px";
		document.body.appendChild(tmpDiv);
		this._scrollBarSize = 100 - tmpDiv.scrollWidth; //滚动条宽度
		document.body.removeChild(tmpDiv);
	
		if(Global.isIE6){
			this.fix4IE6();
			this.resizeBodyHeight();
		}
		
		if(Global.ltIE8){
			this.resizeTableWidth();
			var me = this;
			// 窗体大小改变
			$(window).on('resize', function(e) {
				if(me._resizeing){ // 浏览器会多次触发resize，为了减少计算次数，添加一个动态锁
					return;
				}
				me._resizeing = true;
				setTimeout(function(){
					me.resizeTableWidth();
					me._resizeing = false;
				}, 10);
			});
		}else{
			$(this.tableCls).width('100%');
		}
	},
	
	_bindEvent4IE6: function(){
		var me = this;
		// 窗体大小改变
		$(window).on('resize', function(e) {
			me.fix4IE6(); // 最外层架构
			if(me._resizeing4IE6){ // 浏览器会多次触发resize，为了减少计算次数，添加一个动态锁
				return;
			}
			me._resizeing4IE6 = true;
			setTimeout(function(){
				me.resizeBodyHeight();
				me._resizeing4IE6 = false;
			}, 10);
		});
	},
	// 计算IE6下UI布局
	fix4IE6: function(){
		var cfg = this.config || [];
		for(var i=0; i<cfg.length; i++){
			var fixX = cfg[i].fixX;
			var fixY = cfg[i].fixY;
			if(fixX === 'undefined'){
				fixX = 0;
			}
			if(fixY === 'undefined'){
				fixY = 0;
			}
			var el = $(cfg[i].selector);
			var pEl = $(cfg[i].selector).parent();
			//log.log($.toJSON(['父节点', pEl.width(), pEl.height()]));
			//log.log($.toJSON(['子节点', pEl.width() + fixX, pEl.height() + fixY]));
			el.width(pEl.width() + fixX);
			el.height(pEl.height() + fixY);
		}
	},
	// resize .body高度
	resizeBodyHeight: function(){
		var app = $(this.appCls);
		var h = $(this.headCls);
		var b = $(this.bodyCls);
		var f = $(this.footCls);
		// 1是bodyCls 底部的 1px border
		b.height(app.height() - h.outerHeight() - f.outerHeight());
	},
	// resize .boxtable宽度
	resizeTableWidth: function(){
		var table = $(this.tableCls);
		var pEl = table.parent();
		if(Global.isIE6){
			table.width(10); // 先缩小宽度以下防止影响上级容器大小
		}
		table.width(pEl.width() - this._scrollBarSize);
	}
});