/**
 * 期权UI
 * @author: 卢海宁<luhaining@myhexin.com>
 * @create: 2014-05-08
 */
 window.hprice = 0;
 window.rtype = 0;
 window.ddate = null;
var Option = Panel.extend({
	// 坐标参数Panel对象
	coordargsObj: null,
	// 图表Panel对象
	chatargsObj: null,
	// 添加期权选择器
	addCls: null,
	// 删除期权选择器
	delCls: null,
	// 批量删除期权选择器
	delsCls: null,
	// 期权列表选择器
	optionsCls: null,
	// 期权到期日选择器
	dateCls: null,
	// 期权行权价选择器
	strikeCls: null,
	// 期权认购认沽选择器
	cpCls: null,
	// 股票参数选择器
	stockCls: null,
	// 股票现价选择器
	nowCls: null,
	// 期权是否激活选择器
	actckCls: null,
	// 股票买卖选择器
	dealCls: null,
	// 股票数量选择器
	qtyCls: null,
	// 期权数量选择器
	qqtyCls: null,    //update
	// 股票价格选择器
	priCls: null,
	// 曲线组合选择器
	portfolioCls: null,
	// 当前标的代码
	code: null,
	// 当前标的市场代码
	market: null,
	// 当前标的ETF标志
	isetf: null,
	// 当前标的现价
	_price: null,
	// 当前标的到期日集合
	_dates: null,
	// 当前标的到期日集合HTML
	_datesHTML: null,
	// 当前标的行权价集合
	_prices: null,
	// 当前标的行权价集合HTML
	_pricesHTML: null,
	// 正在重置
	_reseting: null,
	// 当天时间 00:00 Date对象
	_now: null,
	// 最近到期日
	_lastestDate: null,
	// 最近到期日序号
	_lastestDateIdx: null,
	
	_initialize: function(cfg){
		this._dates = [];
		this._prices = [];
		this._reseting = false;
		this._now = new Date();
		this._now.setHours(0);
		this._now.setMinutes(0);
		this._now.setSeconds(0);
		this._now.setMilliseconds(0);
	},
	/*
	 * 渲染期权条件下拉菜单
	 * @param option Array 接口返回的
	 */
	readyOption: function(option){
		var $stock = $(this.baseCls).find(this.stockCls);
		$stock.find(this.qtyCls).val(1).attr('ovalue', 1);
		$stock.find(this.nowCls).val(option.price).attr('ovalue', option.price);
	
		$('.loading').hide();
		if(!this.coordargsObj){
			this.coordargsObj = new Coordargs({
				optionsObj: this,
				baseCls: '.coordargs',
				price: option.price,
				volatility: option.zgbdl,
				xaxisCls: '.xaxis',
				yaxisCls: '.yaxis',
				priceCls: '.price',
				volCls: '.vol',
				dateCls: '.date',
				rateCls: '.rate'
			});
		}else{
			this.coordargsObj.price = option.price;
			this.coordargsObj.volatility = option.zgbdl;
			this.coordargsObj.reset();
		}
		if(!this.chatargsObj){
			this.chatargsObj = new Chatargs({
				optionsObj: this,
				coordargsObj: this.coordargsObj,
				baseCls: '.chatargs',
				price: option.price,
				volatility: option.zgbdl,
				dateCls: '.date',
				nowCls: this.nowCls,
				portfolioCls: '#portfolio',
				priinputCls: '#priinput',
				volinputCls: '#volinput',
				ratinputCls: '#ratinput',
				prisliderCls: '#prislider',
				volsliderCls: '#volslider',
				ratsliderCls: '#ratslider'
			});
		}else{
			this.chatargsObj.price = option.price;
			this.chatargsObj.volatility = option.zgbdl;
			this.chatargsObj.reset();
		}
		 //判断横坐标初始化
		var $chart = $('.chatargs');
			// var $opts = $base.find(this.optionsCls).find('tr');
			var volspinner = $chart.find('#volinput').spinner();
			var prispinner = $chart.find('#priinput').spinner();
			var volslider = $chart.find('#volslider').slider();
			var prislider = $chart.find('#prislider').slider();
			var val = $('.coordargs').find('.xaxis:eq(0)').val();
			var oval = $('.coordargs').find('.xaxis:eq(1)').val();
			volspinner.spinner({ step: 0.001, numberFormat: "n3" });
			if (val == 2 && oval == 2){
				volspinner.spinner('enable');
				volslider.slider('enable');
				prispinner.spinner('enable');
				prislider.slider('enable');
			} else if(val ==0 && oval ==0){
			  	     prispinner.spinner('disable');
				     prislider.slider('disable');
				     volspinner.spinner('enable');
					 volslider.slider('enable');
			} else if (val == 1 && oval == 1){
				      prispinner.spinner('enable');
					   prislider.slider('enable');
				     volspinner.spinner('disable');
					 volslider.slider('disable');
			} else if ((val == 0 || val == 1) && (oval == 0 || oval == 1)){
				     prispinner.spinner('disable');
					 prislider.slider('disable');
				     volspinner.spinner('disable');
					 volslider.slider('disable');
			} else if (val == 0 || oval ==0){
				     prispinner.spinner('disable');
					  prislider.slider('disable');
				     volspinner.spinner('enable');
					 volslider.slider('enable');
			} else if(val == 1 || oval ==1){
				     volspinner.spinner('disable');
				     volslider.slider('disable');
				     prispinner.spinner('enable');
					 prislider.slider('enable');
				    
			}
	//  $chart.find('#volinput').val(parseFloat(option.zgbdl, 10).toFixed(3));
	},
	_bindEvent: function(){
		var me = this;
		var that = this;
		var $base = $(this.baseCls);
		var ch = $('.chatargs').find('#priinput');
		var chs = $('.chatargs').find('#prislider');
		// 切换选中checkbox
		$base.on('change', this.actckCls, function(e) {
			me.calcOption();
		});
		// 切换买卖
		$base.on('change', this.dealCls, function(e) {
			var cls = (this.options[this.selectedIndex].value == 0 ? 'buy' : 'sell');
			var $el = $(this);
			$el.removeClass().addClass('deal ' + cls);
			me.calcOption($el.parents('tr').attr('qid') || 'code');
		});
		// 改变现价2位小数 0.01 - 999.99
		
		$base.on('change', this.nowCls, function(e){
			var oval = parseFloat(this.getAttribute('ovalue'), 10).toFixed(3);
			var val = parseFloat(this.value, 10).toFixed(3);
			ch.spinner({
				min: 0.001,
				max: 999.999,
				step: 0.001,
				numberFormat: 'n3'
			});
			chs.slider({
			min: 1,
			max: 999999
		   });
			if (that.isetf == 0)
			{
				ch.spinner({
				min: 0.01,
				max: 999.99,
				step: 0.01,
				numberFormat: 'n'
			   });
			    chs.slider({
			    min: 1,
			    max: 99999
		        });
				oval = parseFloat(this.getAttribute('ovalue'), 10).toFixed(2);
		        val = parseFloat(this.value, 10).toFixed(2);
				if(isNaN(this.value) || this.value < 0.01 || this.value > 999.99){
				var obj = {
					code: that.code,
					market: that.market,
					func: function(price){
					}
				}				
				var price = thsOptionRisk.getTargetNPrice(obj);
			if (price != '')
				{
					this.value = parseFloat(price, 10).toFixed(2);
				}
			else{
					this.value = oval;
				}
				//return;
			}else{
				  this.value = val;
			     }
			}  else {
			if(isNaN(this.value) || this.value < 0.001 || this.value > 999.999){
				var obj = {
					code: that.code,
					market: that.market,
					func: function(price){
					}
				}				
				var price = thsOptionRisk.getTargetNPrice(obj);
			 if (price != '')
				{
				 
					this.value = parseFloat(price, 10).toFixed(3);
				}
			else{
					this.value = oval;
				}
				//return;
		}else{
				this.value = val;
			}
		}
			val = this.value;
			if(val == oval){
				return;
			}else{
				//alert(8)
				this.setAttribute('ovalue', val);
				if(me.coordargsObj){
					me.coordargsObj.setPrice(val);
				}
				if(me.chatargsObj){
					me.chatargsObj.setPrice(val);
				}
				me.calcOption('code');
			}
		});
		// 切换到期日
		$base.on('change', this.dateCls, function(e) {
			// 判断Key是否重复
			var d = this.value;
			var $el = $(this);
			var $tr = $el.parents('tr');
			var $tbody = $el.parents('tbody');
			var $price =  $el.parent().next().find('select');
			var op = $price.val();
			$price.empty();
			$price.append(me._pricesHTML[d]);
			$price.val(op);
			
			var qid, i,
				ps = me._prices[d];
			if($price.prop('selectedIndex') == -1){ // 无效行权价，遍历行权价
				for(i=0; i<ps.length; i++){
					qid = [d, ps[i], $tr.find(me.cpCls).val()].join('_');
					if($tbody.find('tr[qid="' + qid + '"]').length == 0){
						$tr.attr('qid', qid);
						$price.val(ps[i]);
						$tr.find(me.priCls).attr('ovalue', '0.0000').val('0.0000'); // 清空价格
						me.calcOption(qid);
						return;
					}
				}
				// 无效切换，还原
				$el.val($tr.attr('qid').substr(0, 8));
				$price.empty();
				$price.append(me._pricesHTML[this.value]);
				$price.val(op);
			}else{ // 固定行权价
				qid = [d, $price.val(), $tr.find(me.cpCls).val()].join('_');
				if($tbody.find('tr[qid="' + qid + '"]').length == 0){
					$tr.attr('qid', qid);
					$tr.find(me.priCls).attr('ovalue', '0.0000').val('0.0000'); // 清空价格
					me.calcOption(qid);
				}else{ // 无效切换，还原
					$el.val($tr.attr('qid').substr(0, 8));
					$price.empty();
					$price.append(me._pricesHTML[this.value]);
					$price.val(op);
				}
			}
		});
		// 切换行权价
		$base.on('change', this.strikeCls, function(e) {
			// 判断Key是否重复
			var $el = $(this);
			var $tr = $el.parents('tr');
			var $tbody = $el.parents('tbody');
			var qid = [$tr.find(me.dateCls).val(), $tr.find(me.strikeCls).val(), $tr.find(me.cpCls).val()].join('_');
			if($tbody.find('tr[qid="' + qid + '"]').length == 0){
				$tr.attr('qid', qid);
				$tr.find(me.priCls).attr('ovalue', '0.0000').val('0.0000'); // 清空价格
				me.calcOption(qid);
			}else{
				$el.val($tr.attr('qid').split('_')[1]);
			}
		});
		// 切换认购认沽
		$base.on('change', this.cpCls, function(e) {
			// 判断Key是否重复
			var $el = $(this);
			var $tr = $el.parents('tr');
			var $tbody = $el.parents('tbody');
			var qid = [$tr.find(me.dateCls).val(), $tr.find(me.strikeCls).val(), $tr.find(me.cpCls).val()].join('_');
			if($tbody.find('tr[qid="' + qid + '"]').length == 0){
				$tr.attr('qid', qid);
				$tr.find(me.priCls).attr('ovalue', '0.0000').val('0.0000'); // 清空价格
				me.calcOption(qid);
			}else{
				$el.val($tr.attr('qid').split('_')[2]);
			}
		});
		// 保证数量整数 1 - 100000
		$base.on('change', this.qtyCls, function(e){
		if (this.value.indexOf('.') != -1){
			  this.value = 1;
			}
			var oval = parseInt(this.getAttribute('ovalue'), 10);
			var val = parseInt(this.value, 10);
		if (this.value == '')
		{
			this.value = 1;
		}
		 else if(isNaN(this.value)){
				this.value = 1;
				//return;
			}else if(val < 1){
				this.value = 1;
			}else if(val > 100000){
				this.value = 1;
			}else{
				this.value = val;
			}
			val = this.value;
			if(val == oval){
				return;
			}else{
				var $el = $(this);
				me.calcOption($el.parents('tr').attr('qid') || 'code');
				this.setAttribute('ovalue', val);
			}
		});
		// 保证数量整数 1 - 10000
		$base.on('change', this.qqtyCls, function(e){
			if (this.value.indexOf('.') != -1){
				this.value = 1;
			}
			var oval = parseInt(this.getAttribute('ovalue'), 10);
			var val = parseInt(this.value, 10);
			if (this.value == '')
			{
				this.value = 1;
			}else if(isNaN(this.value)){
				this.value = 1;
				//return;
			}else if(val < 1){
				this.value = 1;
			}else if(val > 10000){
				this.value = 1;
			}else{
				this.value = val;
			}
			val = this.value;
			if(val == oval){
				return;
			}else{
				var $el = $(this);
				me.calcOption($el.parents('tr').attr('qid') || 'code');
				this.setAttribute('ovalue', val);
			}
		});
		
		/*$base.on('keyup', this.priCls, function(e){
		var oval = parseFloat(this.getAttribute('ovalue'), 10).toFixed(4);
		if (this.value > 999)
		{
		      this.value =oval;
			  alert("输入的数量不能超过999！请重新输入");
			  }
		});*/
		// 保证价格4位小数 0.0001 - 999.9999
		
		$base.on('change', this.priCls, function(e){
			var $opts = $base.find(me.optionsCls).find('tr');
			$opts.each(function(idx, el){
				var $o = $(el);
				var v = $o.find(me.priCls).val()
				if (isNaN(v) || v < 0.0001 || v > 999){
				ddate = $o.find(me.dateCls).val();
				hprice = $o.find(me.strikeCls).val();
				rtype =	$o.find(me.cpCls).val();
				}
				// type: 0表示认购, 1表示认沽; nprice: 表示现价; trade: 0表示买, 1表示卖
			});
			var oval = parseFloat(this.getAttribute('ovalue'), 10).toFixed(4);
			var val = parseFloat(this.value, 10).toFixed(4);
			if(isNaN(this.value) || this.value < 0.0001 || this.value > 999){
			var price = thsOptionRisk.getOptionNPrice({
				code: that.code,
				market: that.market,
				cdate: ddate,
				cprice: hprice,
				type: rtype,
				func: function(price){
				//	log.log(xml);
				  //var data = $.xml2json(xml);
				//  this.value =  parseFloat(price, 10).toFixed(4);
				}
			}); 
			  if (price != ''){
				  this.value =parseFloat(price, 10).toFixed(4);
			  }
			  else{
			    this.value = oval;
			  }
				//return;
			}else{
				this.value = val;
			}
			val = this.value;
			if(val == oval){
				return;
			}else{
				var $el = $(this);
				me.calcOption($el.parents('tr').attr('qid'));
				this.setAttribute('ovalue', val);
			}
		});
		// 添加期权
		$base.on('click', this.addCls, function(e){
			// alert("---------fffff");
			me.addOption();
		});
		// 删除期权
		$base.on('click', this.delCls, function(e){
			$(this).parents('tr').remove();
			me.calcOption();
		});
		// 批量删除期权
		$base.on('click', this.delsCls, function(e){
			$(me.baseCls).find(me.optionsCls).find('tr').each(function(idx, el){
				var $opt = $(el);
				if($opt.index() != 0 && $opt.find('input[type=checkbox]').prop('checked')){
					$opt.remove();
				}
			});
			me.calcOption();
		});
	},
	
	_request: function(){
		var me = this;
		// 获取标的代码的期权参数
		
		var xml = thsOptionRisk.getOptionParam({
			code: this.code,
			market: this.market,
			func: function(xml){
				// alert('xml---------'+xml)
				me.getOptionCallback(xml);
			}
		});
		// alert('_request------------'+xml)
		if(xml){ // 有数据返回时，直接回调
		 
			this.getOptionCallback(xml);
			
		} 
		if(Global.debug){
			/*
				<option_param target="600000" price="9.70" zgbdl="9.33">
					<cdate>
						<item val="20140412"/>
					</cdate>
					<cprice>
						<item val="185.0"/>
						<item val="185.5" default="1"/>
						<item val="186.0"/>
					</cprice>
				</option_param>
				<option_param target="600000" price="9.70" zgbdl="1.33">
					<cdate val="20140412">
						<item val="185.0"/>
						<item val="185.5"/>
						<item val="186.0"/>
					</cdate>
					<cdate val="20140512">
						<item val="186.0"/>
						<item val="186.5"/>
						<item val="187.0"/>
					</cdate>
				</option_param>
			*/
			xml = '<option_param target="600000" price="9.70" zgbdl="1.33"><cdate val="20140412"><item val="185.0"/><item val="185.5"/><item val="186.0"/></cdate><cdate val="20140512"><item val="186.0"/><item val="186.5"/><item val="187.0"/></cdate></option_param>';
			//xml = '<option_param target="600000" price="9.70" zgbdl="9.33"><cdate><item val="20140617" /><item val="20140412" /><item val="20140512"/><item val="20140612"/></cdate><cprice><item val="185.0"/><item val="185.5" default="1"/><item val="186.0"/></cprice></option_param>';
			this.getOptionCallback(xml);
		}
	// }	
	},
	/*
	 * 获取期权参数回调函数
	 * @param xml String
	 */
	getOptionCallback: function(xml){
		log.log(xml);
		var data = $.xml2json(xml);
		// 格式化现价
		data.price = parseFloat(data.price, 10);
		var pri = $('.chatargs').find('#priinput');
		var pris = $('.chatargs').find('#prislider');
		if (1 == data.isetf)
		{
			data.price = isNaN(data.price) ? '0.000' : data.price.toFixed(3);
			pri.spinner({
				min: 0.001,
				max: 999.999,
				step: 0.001,
				numberFormat: 'n3'
			}).attr('ovalue', data.price).spinner('value', data.price);
			pris.slider({
			min: 1,
			max: 999999
		    }).slider('value', data.price*1000);
		}
		else{
			data.price = isNaN(data.price) ? '0.00' : data.price.toFixed(2);
			pri.spinner({
				min: 0.01,
				max: 999.99,
				step: 0.01,
				numberFormat: 'n2'
			}).attr('ovalue', data.price).spinner('value', data.price);
			pris.slider({
			min: 1,
			max: 99999
		    }).slider('value', data.price*100);
		}
		window.etftype = data.isetf;

		data.zgbdl = parseFloat(data.zgbdl, 10);
		data.zgbdl = isNaN(data.zgbdl) ? '0.000' : data.zgbdl.toFixed(3);
		this._price = data.price;
		// 格式化日期、价格，计算最近到期日、从小到大排序价格
		var cdate =  [].concat(data.cdate || []);
		this._dates = []; // 清空
		this._prices = {}; // 清空
		this._pricesHTML = {}; // 清空
		
		var i, j, d, tmpp,
			html = ['<select class="expiry">'],
			phtml;
		for(i=0; i<cdate.length; i++){
			d = cdate[i].val;
			this._dates.push(d);
			// 保存到期日文本
			html.push('<option value="', d, '">', d.substr(0, 6), '</option>');
			var prices =  [].concat(cdate[i].item || []);
			for(j=0; j<prices.length; j++){
				if(j == 0){
					this._prices[d] = [];
				}
				tmpp = parseFloat(prices[j].val, 10).toFixed(4);
				this._prices[d].push(tmpp);
			}
			this._prices[d].sort();
			
			// 保存行权价文本
			//phtml = ['<select class="strike">'];
			phtml = [];
			for(j=0; j<this._prices[d].length; j++){
				phtml.push('<option value="', this._prices[d][j], '">', this._prices[d][j], '</option>');
			}
			//phtml.push('</select>');
			this._pricesHTML[d] = phtml.join('');
		}
		html.push('</select>');
		this._datesHTML = html.join('');
		this.calcLastestDate();
		this.readyOption(data);
		
	},
	/*
	 * 切换标的
	 * @param code String 标的代码
	 * @param market String 市场代码
	 */
	changeCode: function(code, market,isetf){
		this.code = code;
		this.market = market;
		this.isetf = isetf;
		etftype = isetf;
		$(this.optionsCls).html('');
		this._request();
	},
	/*
	 * 添加期权
	 * @param first Boolean 是否首次添加期权
	 */
	addOption: function(first){
		// alert(first);
		var idxCfg;
		if(first){
			if(typeof(this._lastestDate)=='undefined' || !this._lastestDate){
				return;
			}
			idxCfg = {
				qid: [this._lastestDate, this._prices[this._lastestDate][0], 0].join('_'),
				date: this._lastestDate,
				dateIdx: this._lastestDateIdx,
				priIdx: 0,
				typeIdx: 0
			}
		}else{
			idxCfg = this.getNewQid();
		}
		if(!idxCfg){
			return;
		}
		var html = [];
		var tmpp = parseFloat(this._price, 10).toFixed(4);
		var $opts = $(this.optionsCls);
		html.push(
			'<tr qid="', idxCfg.qid, '">',
				'<td class="tac"><input class="actck" type="checkbox" checked="checked"/></td>',
				'<td class="tac">', ($opts.find('tr').length == 0 ? '&nbsp;' : '<input type="button" class="ictrash" value="&nbsp;"/>'), '</td>',
				'<td class="tac">',
					'<select class="deal buy">',
						'<option class="buy" value="0">买</option>',
						'<option class="sell" value="1">卖</option>',
					'</select>',
				'</td>',
				'<td class="tar"><input class="intext qqty" type="text" value="1" ovalue="1"/></td>', //update
				'<td class="tar"><input class="intext pri" type="text" value="0.0000" ovalue="0.0000"/></td>',
				'<td class="tac">',
					this._datesHTML,
				'</td>',
				'<td class="tac">',
					'<select class="strike">',
						this._pricesHTML[idxCfg.date],
					'</select>',
				'</td>',
				'<td class="tac">',
					'<select class="cp">',
						'<option value="0">认购</option>',
						'<option value="1">认沽</option>',
					'</select>',
				'</td>',
				'<td class="tar pr">0.00%</td>',
				'<td class="tar bl72">0.00</td>',
				'<td class="tar">0.00</td>',
				'<td class="tar">0.00</td>',
				'<td class="tar pr">0.00</td>',
			'</tr>');
		var $newopt = $opts.append(html.join('')).find('tr:last');
		$newopt.find('.strike').prop('selectedIndex', idxCfg.priIdx);
		$newopt.find('.expiry').prop('selectedIndex', idxCfg.dateIdx);
		$newopt.find('.cp').prop('selectedIndex', idxCfg.typeIdx);
		
		this.calcOption( first ? 'all' : idxCfg.qid );
	},
	/*
	 * 获取新期权Key
	 */
	getNewQid: function(){
		var qid = '',
			i, j, k, d, ps, tmpid, $rlt,
			$opts = $(this.baseCls).find(this.optionsCls);
		for(i=0; i<2; i++){ // 认购认沽
			for(j=0; j<this._dates.length; j++){ // 到期日
				d = this._dates[j]; // 日期
				ps = this._prices[d];
				for(k=0; k<ps.length; k++){ // 行权价
					tmpid = [d, ps[k], i].join('_');
					$rlt = $opts.find('tr[qid="' + tmpid + '"]');
					if($rlt.length == 0){
						qid = tmpid;
						return {
							qid: qid,
							date: d,
							dateIdx: j,
							priIdx: k,
							typeIdx: i
						};
					}
				}
			}
		}
		
		return null;
	},
	/*
	 * 计算期权
	 * @param calc String 是否计算 
	 * 		all表示计算
	 * 		code 计算股票标的
	 * 		Key 需要计算的Key
	 * 		空则不计算
	 */
	calcOption: function(calc){
		log.log('calcOption...' + (calc ? calc : 'None.'));
		if(this._reseting){
		  return;
		}
		/*
		 * @param Object
		 * 	code 股票代码
		 * 	market 市场代码
		 * 	calc 0表示不计算标的，1表示计算标的
		 * 	options: [ 期权数组
		 * 		{
		 * 			type 0表示认购 1表示认沽
		 * 			cprice 行权价
		 * 			cdate 到期日
		 * 			vol 数量（手）
		 * 			nprice 股价
		 * 			trade 0表示买 1表示卖
		 * 		},
		 * 		{}...
		 * 	]
		<calc_param>
			<target calc= "1" select="1" market="17" code="600000"  price="186" vol="10000" wfxll="12.0" zgbdl="12.0"/>
			<axis group=0> //0表示不组合, 1表示组合.
				<item type=0  y=0 x=0 price=18.8 /> 
				<item type=1  y=0 x=0 price=18.8 />
			</axis>
			<option> //type, 0表示认购 1表示认沽; nprice表示现价； trade，0表示买, 1表示卖.
			   <item select="1" calc="1" type="0" cprice="185.5" cdate="20140412" nprice="186.0" vol="100000" trade="0" />
			   <item select="1" calc="0" type="1" cprice="186.0" cdate="20140412" nprice="186.0" vol="100000" trade="1" />
			</option>
		</calc_param>
		 */
		var me = this;
		
		var $base = $(this.baseCls);
		var $code = $base.find(this.stockCls);
		var $coord = $(this.coordargsObj.baseCls);

		var $opts = $base.find(this.optionsCls).find('tr');
		var xml = ['<?xml version="1.0" encoding="GB2312"?>',
				'<calc_param>'];
		// 标的参数	
		xml.push('<target calc="', (calc=='code'||calc=='all' ? '1':'0'),
					//'" select="', ($code.find(this.actckCls).is(':checked')?'1':'0'), // 0表示不选中, 1表示选中
					'" select="', '1', // 强制选中
					'" market="', this.market,
					'" code="', this.code,
					'" trade="', $code.find(me.dealCls).val(), 
					//'" price="', this._price,
					'" price="', this.coordargsObj.getPrice(),
					'" vol="', $code.find(this.qtyCls).val()*100,
					'" zgbdl="', this.coordargsObj.getVolatility(),
					'" wfxll="', this.coordargsObj.getRate(),
					'" />');
		// 坐标参数
		xml.push('<axis group="', ($(this.portfolioCls).is(':checked')?'1':'0'), '">', // 0表示不组合, 1表示组合
					'<item type="0"  y="', $coord.find('.yaxis:eq(0)').val(),
						'" x="', $coord.find('.xaxis:eq(0)').val(), 
						'" price="', this.coordargsObj.getPrice(), '" />',
					'<item type="1"  y="', $coord.find('.yaxis:eq(1)').val(), 
						'" x="', $coord.find('.xaxis:eq(1)').val(), 
						'" price="', this.coordargsObj.getPrice(), '" />',
				'</axis>');
		// 期权参数	
		xml.push('<option>');
		
		$opts.each(function(idx, el){
			var $o = $(el);
			// type: 0表示认购, 1表示认沽; nprice: 表示现价; trade: 0表示买, 1表示卖
			
			xml.push('<item select="', ($o.find(me.actckCls).is(':checked')?'1':'0'), 
						// '" calc="', (calc==$o.attr('qid')||calc=='all'?'1':'0'), 
						'" calc="1" trade="', $o.find(me.dealCls).val(), 
						'" nprice="', $o.find(me.priCls).val(), 
						'" vol="', $o.find(me.qqtyCls).val()*100, 
						'" cdate="', $o.find(me.dateCls).val(), 
						'" cprice="', $o.find(me.strikeCls).val(), 
						'" type="', $o.find(me.cpCls).val(), 
						'" />');
		});
		xml.push('</option>');
		xml.push('</calc_param>');
		
		// alert(xml.join(''));
		// 获取标的代码
		var resultxml = thsOptionRisk.calcOptionRiskData(xml.join(''));
		if(Global.debug){
			/*
				<calc_result>
					<target market="17" code="600000" delta="14.41" gamma="6.69" theta="-1.92" vega="2.13" calc="1"/>
					<option>
						<item type="0" price="100.25" cprice="185.5" cdate="20140412" yhbdl="0.10312" delta="64.4104000" gamma="26.6914000" theta="-13.9291400" vega="5.1391400"/>
						<item type="0" price="110.25"  cprice="186.0" cdate="20140412" yhbdl="0.10312" delta="64.4145789" gamma="26.6914000" theta="-13.9291400" vega="5.1391400"/>
					</option>
				</calc_result>
			*/
			resultxml = '<calc_result><target market="17" code="600000" delta="14.41" gamma="6.69" theta="-1.92" vega="2.13"/><option><item type="0" calc="1" price="100.25" cprice="185.5" cdate="20140412" yhbdl="0.103" delta="64.41" gamma="26.69" theta="-13.92" vega="5.13"/><item type="0" price="110.25" cprice="186.0" cdate="20140412" yhbdl="0.103" delta="64.41" gamma="26.69" theta="-13.92" vega="5.13"/></option></calc_result>';
		}
		log.log(resultxml);
		var data = $.xml2json(resultxml);
		// alert("-----" + $.toJSON(data));
		this.renderOptions(data.target, [].concat(data.option.item || []));
	},
	/*
	 * 渲染期权计算结果
	 * @param cfg Object 标的相关计算结果，接口返回的数据
	 * @param opts Array 接口返回的数据
	 */
	renderOptions: function(cfg, opts){
		var $base = $(this.baseCls);
		//alert($.toJSON(cfg));
		if(cfg.calc == 1){
			var $stock = $base.find(this.stockCls).find('tr');
			var vol = parseInt($stock.find('td:eq(-7) input').val(), 10)*100;
			$stock.find('td:eq(-4)').html((parseFloat(cfg.delta, 10)*vol).toFixed(2));
			$stock.find('td:eq(-3)').html((parseFloat(cfg.gamma, 10)*vol).toFixed(2));
			$stock.find('td:eq(-2)').html((parseFloat(cfg.theta, 10)*vol).toFixed(2));
			$stock.find('td:eq(-1)').html((parseFloat(cfg.vega, 10)*vol).toFixed(2));
		}
		var $opts = $base.find(this.optionsCls);
		for(var i=0; i<opts.length; i++){
			var opt = opts[i];
			if(opt.calc != 1){
				continue;
			}
			var qid = [opt.cdate, parseFloat(opt.cprice, 10).toFixed(4), opt.type].join('_'); // 组合id
			var $opt = $opts.find('tr[qid="' + qid + '"]');
			if($opt.length != 1){
				continue;
			}
			var price = parseFloat(opt.price, 10).toFixed(4);
			var num = parseInt($opt.find('td:eq(-10) input').val(), 10); // 数量
			$opt.find('td:eq(-9)').find('input').val(price).attr('ovalue', price);
			$opt.find('td:eq(-5)').html((parseFloat(opt.yhbdl, 10)*100).toFixed(2) + '%');
			$opt.find('td:eq(-4)').html((parseFloat(opt.delta, 10)*num).toFixed(2));
			$opt.find('td:eq(-3)').html((parseFloat(opt.gamma, 10)*num).toFixed(2));
			$opt.find('td:eq(-2)').html((parseFloat(opt.theta, 10)*num).toFixed(2));
			$opt.find('td:eq(-1)').html((parseFloat(opt.vega, 10)*num).toFixed(2));
		}
		this.calcTotal();
	},
	/*
	 * 计算delta/gamma/theta/vega总和
	 */
	calcTotal: function(){
		var $base = $(this.baseCls);
		var $stock = $base.find(this.stockCls).find('tr');
		var $opts = $base.find(this.optionsCls).find('tr');
		var tdelta = tgamma = ttheta = tvega = 0;
		
		tdelta += Math.round(parseFloat($stock.find('td:eq(-4)').text())*100, 10)/100;
		tgamma += Math.round(parseFloat($stock.find('td:eq(-3)').text())*100, 10)/100;
		ttheta += Math.round(parseFloat($stock.find('td:eq(-2)').text())*100, 10)/100;
		tvega += Math.round(parseFloat($stock.find('td:eq(-1)').text())*100, 10)/100;
		
		for(var i=0; i<$opts.length; i++){
			var $opt = $($opts[i]);
			tdelta += Math.round(parseFloat($opt.find('td:eq(-4)').text())*100, 10)/100;
			tgamma += Math.round(parseFloat($opt.find('td:eq(-3)').text())*100, 10)/100;
			ttheta += Math.round(parseFloat($opt.find('td:eq(-2)').text())*100, 10)/100;
			tvega += Math.round(parseFloat($opt.find('td:eq(-1)').text())*100, 10)/100;
		}
		//alert(tdelta);
		var $total = $base.find(this.totalCls);
		$total.find('td:eq(-4)').html(tdelta.toFixed(2));
		$total.find('td:eq(-3)').html(tgamma.toFixed(2));
		$total.find('td:eq(-2)').html(ttheta.toFixed(2));
		$total.find('td:eq(-1)').html(tvega.toFixed(2));
	},
	/*
	 * 计算最近的到期日
	 */
	calcLastestDate: function(){
		this._lastestDate = 0; // 重置
		var idx = 0;
		for(var i=0; i<this._dates.length; i++){
			var date, abs,
				str = this._dates[i];
			try{
				y = parseInt(str.substr(0, 4), 10);
				m = parseInt(str.substr(4, 2), 10);
				d = parseInt(str.substr(6, 2), 10);
				date = new Date(y, m-1, d);
			}catch(e){
				continue;
			}
			abs = Math.abs(this._now - date);
			
			if(abs < Math.abs(this._now - this._lastestDate)){
				this._lastestDate = date;
				idx = i;
			}
		}
		this._lastestDate = this._dates[idx];
		this._lastestDateIdx = idx;
	}
});