/********************************
同花顺客户端js扩展引擎
author: 何玮<away@myhexin.com>
date:	2009-07-06
history:
	2009-07-29
		1. 修改了Passport类。增加了多个通行证读取的功能。
		2. 完善了注释
	2011-11-11 卢海宁<luhaining@myhexin.com>
		1. 根据接口变动，修改部分注释
		2. 增加FileOutputStream.openSupple方法
	2011-11-13 卢海宁<luhaining@myhexin.com>
		1. 增加ThsHttpRequest.request入参timeout 超时时间，默认2秒
		2. 统一ThsHttpRequest.onready回调接口函数名（与jQuery一致）
	2011-11-27 卢海宁<luhaining@myhexin.com>
		1. 增加ThsHttpRequest._handler入参id 对应请求id逻辑，使其支持多并发
*********************************/
(function(){
	
	/*
	* 全局内部函数
	* 1. 获取hexin主程序所在主目录
	* external.getModulePath()
	* @return String
	*
	* 2. 获取当前用户使用的目录
	* external.getuserPath()
	* @return String
	*/
	var unsupport = false;
	try{
		thsAjax		= external.createObject('Ajax');
	}catch(e){	
		unsupport = true;
		try {
			console.log('当前环境不支持external.createObject方法，应用将以浏览器模式运行！');
		}catch(ex){}
	}finally{
		if(unsupport){
			return;
		}
	}
	
	thsQuote		= external.createObject('Quote');
	
	thsAudioEngine	= external.createObject('AudioEngine');
	/**
	* 和thsQuote相关的内部函数
	* 1. 页面切换函数
	* thsQuote.switchPage(param)
	* @param param	Object
	*		param.id		Int		页面id
	*		param.code		String	切换代码
	*		param.period	Int		切换周期
	* @param param	Int		页面id
	* @return void
	*
	* 2. 切换板块函数
	* theQuote.switchBlock(param)
	* @param param	Object
	*		param.id			板块id
	*		param.code			切换后的当前代码
	* @param param	Int			板块id
	* @param param	String		板块名称
	* @return void
	*
	* 3. 调用一个菜单命令
	* theQuote.actionCommand(cmdId)
	* @param cmdId	Int			菜单的资源Id
	*
	* 4. 切换当前页面的标签
	* theQuote.switchTab(tabName)
	* @param tabName String		标签名称
	* @return boolean
	*
	* 5. 向指定绘图对象发起命令
	* theQuote.setWindowCommand(param)
	* @param param	Object
	*			param.name		窗口名称
	*			param.cmd		发起的命令
	*			param.code		切换窗口当前代码
	*			param.period	切换窗口当前周期
	*
	*/

	thsPassport		= external.createObject('Passport');
	
	thsIM 			= external.createObject('InstantMessager');

	thsUtil			= external.createObject('Util');
	
	thsCache		= external.createObject('Cache');
	
	thsFileTransfer = external.createObject('FileTransfer');

//	thsRemoteHelp = external.createObject('RemoteHelp');
	/**
	* 和thsUtil相关的函数
	* 1. 打开url
	* thsUtil.openURL(url, mode);
	* @param url	String	打开的目标url
	* @param mode	Int		打开的类型。0： 在资讯中心打开；1: 在资讯对话框中打开
	* @return void
	*
	* 2. 键盘精灵代码表
	* thsUtil.filterStock(param)
	* @param param Object
	*		param.filter	键盘精灵过滤字符串
	*		param.count		返回的个数限制。如果不指定或指定0，则返回15条
	* @return String	eval后，为一个数组。数组中放置的是对象。每个对象包含以下属性：
	*				stock:	股票代码
	*				name:	股票名称
	*				py:		拼音简称
	*/
})();

// 使用同花顺资讯连接请求数据的对象
ThsHttpRequest = function(){

	var _requestObj	= {};		// private
	var _lastError	= '';		// private

	// 重置请求
	var _reset = function(id) {
		_requestObj[id]	= null;
		delete _requestObj[id];
	}

	// 超时处理
	var _onTimeout = function(id) {
		thsAjax.cancel(id);
		_lastError = 'timeout';
		if (!!_requestObj[id]) {
			var obj = _requestObj[id];
			obj.error.call(obj.scope, obj, 'timeout');
			obj.complete.call(obj.scope, obj, 'timeout');
		}
		_reset(id);
	};

	// 清除超时
	var _clearTimeout = function(id) {
		if (!!_requestObj[id] && !!_requestObj[id]._timeout) {
			clearTimeout(_requestObj[id]._timeout);
		}
	};

	// 数据处理
	var _handler = function(data, id) {
		_clearTimeout(id);
		if (!!_requestObj[id]) {
			var obj = _requestObj[id];
			var fmtrlt = obj.format(data);
			var textStatus = 'success';
			if(fmtrlt.success){
				obj.success.call(obj.scope, fmtrlt.data, obj, textStatus);
			}else{
				textStatus = 'parsererror';
				obj.error.call(obj.scope, obj, textStatus);
			}
			obj.complete.call(obj.scope, obj, textStatus);
		}
		_reset(id);
	};

	// 格式化入参
	var _getOptions = function(obj) {
		var opts = {};
		opts.url = obj.url;
		opts.scope = obj.scope || opts;
		opts.type = obj.serverType;
		if(opts.type === 'undefined'){
			opts.type = 49;
		}
		obj.type = obj.type || 'GET';
		if(!!obj.data){
			var data = '';
			for(var key in obj.data){
				data += key + '=' + obj.data[key] + '&';
			}
			if(obj.type == 'GET'){
				opts.url += '?' + data;
			}else{ // POST
				opts.post = data;
			}
		}
		opts.onready = _handler;
		obj.dataType = obj.dataType || 'text';
		obj.success = obj.success || function(){};
		obj.error = obj.error || function(){};
		obj.complete = obj.complete || function(){};
		obj.format = obj.format || function(data){
			var result = {
				data: data,
				success: true
			};
			if(obj.dataType == 'json' && typeof data == 'string'){
				try{
					result.data = eval('(' + data + ')');
				}catch(e){
					result.success = false;
				}
			}
			return result;
		}
		return {
			opts: opts, // thsAjax请求格式参数
			obj: obj	// 原始请求配置
		};
	};
	
	return {
		/* public 请求接口.
		 * @param obj object 请求的参数
		 *		obj.url				请求的url
		 *		obj.type			请求类型 GET/POST
		 *		obj.data			参数
		 *		obj.scope			作用域
		 *		obj.serverType		资讯服务器类型（49:同花顺资讯服务器，0:券商资讯服务器）
		 *		obj.success(data)	数据收到后的处理函数，单一参数 String
		 *		obj.error			失败处理函数
		 *		obj.complete		请求完成时执行的函数，在success/error之后
		 *		obj.timeout			超时时间限制（默认两秒）
		 *		obj.format			数据返回后格式化方法
		 */
		'request': function(obj) {
			var config = _getOptions(obj);
			var requestId = thsAjax.request(config.opts);
			config.obj._timeout = setTimeout(function(){ 
				_onTimeout(requestId); 
			}, config.obj.timeout || 2000);
			_requestObj[requestId] = config.obj;
			return requestId != 0;
		},
		
		/*
		 * @public 根据type获取服务器http地址
		 * @param Number
		 *		0 同花顺资讯主站
		 *		49 券商资讯主站
		 */
		'getServer': function(type) {
			return thsAjax.getServer(type);
		},

		// public 返回最后一个错误
		'lastError': function() {
			return _lastError;
		}
	};
};

/**
 * 从文件读取内容的类
 */
FileStreamInput = function() {
	var fsi = external.createObject('FileInputStream');
	return {
		/**
		* 打开用于读取的文件
		* @param filename String 需要打开的文件名
		* @return boolean
		*/
		'open':	function(filename) {
			return fsi.open(filename);
		},

		/**
		* 读取文件内容
		* @return String
		*/
		'read':	function() {
			return fsi.read();
		},

		/**
		* 关闭
		* @return void
		*/
		'close': function() {
			fsi.close();
		}
	};
};

/**
 * 将数据写入到文件的类
 * 此接口为单例模式，同时打开的文件只能存在一个
 */
FileStreamOutput = function() {
	var fso = external.createObject('FileOutputStream');
	return {
		/**
		* 打开用于写盘的文件
		* @param filename String 需要打开的文件名
		* @return boolean
		*/
		'open': function(filename) {
			return fso.open(filename);
		},
		
		/**
		* 打开用于写盘的文件，可选择是否追加内容
		* @param filename String 需要打开的文件名
		* @param isAppend boolean 是否追加
		* @return boolean
		*/
		'openSupple': function(filename, isAppend) {
			return fso.openSupple(filename, isAppend);
		},
		
		/**
		* 写入内容
		* @param str String 需要写盘的文件内容
		* @return int|boolean 如果成功返回写入的长度。否则返回false
		*/
		'write': function(str) {
			return fso.write(str);
		},

		/**
		* 关闭文件
		* @return void
		*/
		'close': function() {
			fso.close();
		}
	};
};

Passport = function() {
	return {
		/**
		* 获得自选股列表
		* @return array|false
		*/
		'selfStocks': function() {
			try	{	
				return thsPassport.selfStocks();
			}
			catch (e) {
			}
			return false;
		},
		
		/**
		* 获得持仓股列表
		* @return array()|false
		*/
		'holdStocks': function() {
			try {
				return eval(thsPassport.holdStocks());
			}
			catch (e){
			}
			return false;
		},
		
		/**
		* 获得持仓行业列表
		* @return array()|false
		*/
		'selfIndustries': function() {
			try{
				return thsPassport.selfIndustries().split(',');
			} catch(e){
			}
			return false;
		},

		/*
		* 获得通行证签名段的文本
		* @param passType char 1委托通行证 6同花顺通行证
		* @return String
		*/
		'ppValue':function(passType) {
			return thsPassport.getValue(passType);
		},

		/*
		* 获得通行证签名
		* @param passType char 1委托通行证 6同花顺通行证
		* @return String
		*/
		'ppSignature': function(passType) {
			return thsPassport.getSignature(passType);
		},

		/*
		* 获得通行证中一个键的值
		* @param key 键名
		* @return String
		*/
		'ppGetValue': function(key) {
			return thsPassport.get(key);
		}
	};
};
