/**
 * 期权UI
 * @author: 卢海宁<luhaining@myhexin.com>
 * @create: 2014-08-25
 */
 var cout = 0;
 
var Option = Panel.extend({
	/*
	 * 当前标的配置
	 * |-total String 1-4 组合数量
	 * |-tOrder Array [00, 01, 10, 11]/[00] 组合顺序，首位含义：0->买入 1->卖出；第二位：0->看涨（认购） 1->看跌（认沽）。例，买入看涨即为00
	 * |-numRatio  Array [1, 2, 5, 1]/[1] 组合中合约数量比例
	 * |-dateRule Array [1, -1, 0, 1]/[0] 组合到期日选择规则 1序列的到期日必须大于0序列，相同值序列的日期值必须相同
	 * |-defcode Array ['?HKLG', '?HKLG', '?HKLG', '?HKLG'] 默认选中的合约代码
	 * |-defdate Array ['20140905A', '20140905A', '20140905A', '20140905A']/['20140905A'] 默认选中组合的日期
	 * |-push String 0/1 默认选中的合约默认的数量
	 */
	config: null,
	// 当前标的代码
	code: null,
	// 当前标的市场代码
	market: null,
	// 当前标的最新价
	now: null,
	// 当前标的涨跌
	rise: null,
	// 当前标的涨幅
	gains: null,
	// tip计时器句柄
	_ttimer: null,
	changeDom : "",
	domXMl : "",
	// 当前活动tip 标记
	_tact: {
		x: -1,
		y: -1,
		cprice: null, // 行权价
		nprice: null, // 最新价（期权）
		date: null, // 日期
		type: null // 看涨看跌（认购认沽）类型
	},
	// 当前区域鼠标clientX/clientY
	_txy: {
		cx: 0,
		cy: 0
	},
	// 合约类型代码对应类型
	_ohmap: {
		'00': '买入看涨',
		'01': '买入看跌',
		'10': '卖出看涨',
		'11': '卖出看跌'
	},
	// 不同日期对应的期权(M:表示未除权/A:除权)
	_d2ops: null,
	// 所有到期日集合(M:表示未除权/A:除权)
	_dates: null,
	
	_initialize: function(cfg){
		this.config = {};
		this.code = cfg.code;
		this.market = cfg.market;
		this.now = cfg.nprice;
		this.rise = cfg.rise;
		this.gains = cfg.gains;
		
		this._d2ops = {};
		this._dates = [];
	},
	
	_bindEvent: function(){
		var me = this;
		var $base = $(this.baseCls);
		var $amount = $(this.amountCls);
		//禁止鼠标右键
		function stop(){
		   return false;
		}
		// document.oncontextmenu=stop;
		// 选中合约（单到期日）
		$base.on('click', '.strategy tbody tr', function(e) {
			var $el = $(this);
			if (me.config.coustom == '1'){
				var bool = $el.hasClass('feChange');
				// alert(bool)
				if(bool){
					
				}else{
					return;
				}
			}
			$el.removeClass('feChange');
			$el.parent().find('.sbg53').removeClass('sbg53');
			$el.addClass('sbg53');
			var $tds = $el.find('td');
			var amount = $amount.val();
			// alert(amount)
			var xml = [
				'<?xml version="1.0" encoding="GB2312"?>',
				'<calc_param>',
					'<target market="', me.market, '" code="', me.code, '" nprice="', me.now, '"/>',
					'<option>', // 合约信息 当前策略有几个合约就传几个item type:0表示认购,1表示认沽; nprice表示现价; trade:0表示买,1表示卖
						'<item code="', $tds.eq(0).attr('code'), 
							'" type="', $tds.eq(0).attr('type'), 
							'" trade="', $tds.eq(0).attr('trade'), 
							'" cdate="', $tds.eq(0).attr('date'), 
							'" cprice="', $tds.eq(0).text(), 
							'" nprice="', $tds.eq(2).text(), 
							'" buy="', $tds.eq(3).text(), 
							'" sell="', $tds.eq(4).text(), 
							'" vol="', $tds.eq(1).text()*amount, 
							'"/>',
					'</option>',
				'</calc_param>'];
				// alert(xml)
			log.log(xml.join(''));
			thsOption.calcStrategyChartData(xml.join(''));
		});
		$('.foot').on( 'click', '.utext2', function(){
			try{
				var xml = [
					'<?xml version="1.0" encoding="GB2312"?>',
					'<calc_param>',
						'<target market="', me.market, '" code="', me.code, '" nprice="', me.now, '"/>',
						'<option>'];
				if(me.config.total == 1){ // 单合约组合触发下单
					var $opt = $base.find('.sbg53');
					if($opt.length != me.config.total){ // 未选中合约
						return;
					}
					var $tds = $opt.find('td');
					var amount = $amount.val();
					xml.push('<item code="', $tds.eq(0).attr('code'), 
								'" type="', $tds.eq(0).attr('type'), 
								'" trade="', $tds.eq(0).attr('trade'), 
								'" cdate="', $tds.eq(0).attr('date'),
								'" cprice="', $tds.eq(0).text(), 
								'" nprice="', $tds.eq(2).text(), 
								'" buy="', $tds.eq(3).text(), 
								'" sell="', $tds.eq(4).text(), 
								'" vol="', $tds.eq(1).text()*amount, 
								'"/>');
				}else{ // 多合约组合触发计算
					var $opts = $base.find('td.bg53');
					if($opts.length/5 != me.config.total){ // 选中合约数不符合要求
						return;
					}
					var amount = $amount.val();
					for(var i=0; i<me.config.total; i++){
						xml.push('<item code="', $opts.eq(i*5).attr('code'), 
								'" type="', $opts.eq(i*5).attr('type'), 
								'" trade="', $opts.eq(i*5).attr('trade'), 
								'" cdate="', $opts.eq(i*5).attr('date'),
								'" cprice="', $opts.eq(i*5).text(), 
								'" nprice="', $opts.eq(i*5 + 2).text(), 
								'" buy="', $opts.eq(i*5 + 3).text(), 
								'" sell="', $opts.eq(i*5 + 4).text(), 
								'" vol="', $opts.eq(i*5 + 1).text()*amount, 
								'"/>');
								//alert(xml);
					}
				}
				xml.push('</option>',
					'</calc_param>');
				// log.log('下单：' + xml.join(''));
				// alert(xml)
				thsOption.modifyParam(xml.join('')); // 下单
			}catch(e){
				// alert($.toJSON(e))
			}
		})
		// 切换月份（单到期日）
		$base.on('change', '.strategy thead select', function(e) {
			me.updateSignle(this.value);
		});
		
		// 记录区域内鼠标的坐标
		$base.on('mousemove', '.strategies', function(e) {
			me._txy.cx = e.clientX; // 鼠标X坐标 浏览器可见区域
			me._txy.cy = e.clientY; // 鼠标Y坐标 浏览器可见区域
		});
		// 鼠标停留显示tip（多到期日组合）
		$base.on('mouseenter', '.strategies tbody td', function(e) {
			if(this.innerText == '-'){
				me.resetTip();
				return;
			}
			var $el = $(this);
			var tdIdx = $el.index();
			if(tdIdx%5 != 0){ // 除行权价以为的TD触发时，不处理逻辑
				me.resetTip();
				return;
			}
			var tx = parseInt(tdIdx/5, 10); // 横坐标
			var $tr = $el.parent();
			var ty = $tr.index(); // 纵坐标
			//log.log(['x', tx, 'y', ty]);
			
			if(me._tact.x != tx || me._tact.y != ty){
				me._tact.x = tx;
				me._tact.y = ty;
				var $cp = $tr.find('td:eq(' + tx*5 + ')');
				me._tact.cprice = $cp.text(); // 行权价
				me._tact.nprice = $tr.find('td:eq(' + (tx*5 + 2) + ')').text(); // 最新价（期权）
				me._tact.date = $cp.attr('date'); // 日期
				me._tact.type = $cp.attr('type'); // 看涨看跌（认购认沽）类型
				$('.tip').hide();
			}else{
				return;
			}
			clearTimeout(me._ttimer); // 中断计时
			me._ttimer = setTimeout(function(){
				me.showTip();
			//}, 3000);
			}, 1000);
		});
		
		// 鼠标移出.strategies
		$base.on('mouseleave', '.strategies tbody', function(e) {
			me.resetTip();
		});
		
		// 选中合约（多到期日组合）
		
	   //alert(cout+2);
		$base.on('click', '.strategies tbody td', function(e) {
			try{
			// if (cout != 0){
				// return;
			// }
			// if(this.className.indexOf('bg53') != -1){
				// return;
			// }
			// alert(this.innerText)
			if(this.innerText == '-'){
				return;
			}
			if (me.config.coustom == '1'){
				var bool = $(this).hasClass('feChange');
				// alert(bool)
				if(bool){
					
				}else{
					return;
				}
			}
			$(this).removeClass('feChange');
			var $ss = $('.strategies');
			var gn = this.getAttribute('gn');
			var $el = $(this);
			var row = $el.parent().index();
			var cow = Math.ceil((parseInt($el.index())+1)/5);
			// alert(row+'--'+(parseInt($el.index())+1)+'-'+cow)
			var $gns = $ss.find('td[gn=' + gn + ']');
			// 判断当前选中数是否符合计算准备
			var newOpt = $ss.find('td[gn=' + gn + '].bg53').length == 0;
			if( $ss.find('td.bg53').length/5 < (me.config.total - (newOpt ? 1 : 0))){ // 不满足4个合约选中
				var code = $ss.find('td[gn=' + gn + '].bg53').attr('code');
				// alert( $gns.length)
				// alert($.toJSON(Global.selCode[Global.domName][cow-1])+'--'+cow+'--'+code)
				try{				
					Global.selCode[Global.domName][cow-1] = row;
				}catch(e){
					cha('设置1---------'+$.toJSON(e))
				}
				$gns.removeClass('bg53');
				
				for(var i=0; i<5; i++){
					$gns.eq(row*5 + i).addClass('bg53');
				}
				return;
			}
			var $opt = $gns.eq(5*row);
			var amount = $amount.val();
			
			//var $gns = $ss.find('td[gn=' + gn + ']');
				//var idx = $rows.index($el);
			$gns.removeClass('bg53');
			for(var i=0; i<5; i++){
			$gns.eq(row*5 + i).addClass('bg53');
			}
				
			var xml = [
				'<?xml version="1.0" encoding="GB2312"?>',
				'<calc_param>',
					'<target market="', me.market, '" code="', me.code, '" nprice="', me.now, '" />',
					'<option>'
					];
                    /*	'<item code="', $opt.attr('code'), 
							'" type="', $opt.attr('type'), 
							'" trade="', $opt.attr('trade'), 
							'" cdate="', $opt.attr('date'), 
							'" cprice="', $opt.text(), 
							'" nprice="', $opt.next().next().text(), 
							'" buy="', $opt.next().next().next().text(), 
							'" sell="', $opt.next().next().next().next().text(), 
							'" vol="', $opt.next().text()*amount, 
							'"/>' */
		var arr = Global[me.strategyid]?Global[me.strategyid].split(':'):[];
		// alert(arr+'--'+me.strategyid)
		for(var i=0; i<me.config.total; i++){
				// 合约信息 当前策略有几个合约就传几个item type:0表示认购,1表示认沽; nprice表示现价; trade:0表示买,1表示卖
			/*	if($el.attr('gn') == i){ // 当前选中行
					continue;
				} */				
				$opt = $ss.find('td[gn=' + i + '].bg53');
				arr[i] = arr[i]?arr[i]:1;
				var bs = $opt.eq(1).text()/arr[i];
				// alert($opt.eq(1).text()+'----'+arr[i]+'---'+bs)
				xml.push('<item code="', $opt.eq(0).attr('code'), 
							'" type="', $opt.eq(0).attr('type'), 
							'" trade="', $opt.eq(0).attr('trade'), 
							'" cdate="', $opt.eq(0).attr('date'), 
							'" cprice="', $opt.eq(0).text(), 
							'" nprice="', $opt.eq(2).text(), 
							'" buy="', $opt.eq(3).text(), 
							'" sell="', $opt.eq(4).text(), 
							// '" vol="', $opt.eq(1).text()*amount/bs, 
							'" vol="', $opt.eq(1).text()*amount, 
							'"/>');
				// alert(xml);
			}
			// alert(xml);
			xml.push('</option>',
				'</calc_param>');
			// log.log(xml.join(''));
			
			var rlt = "";
			if(me.domXMl){
				if(me.domXMl == xml.join('')){
				}else{
					// alert(me.domXMl)
					// alert(xml.join(''))
					rlt = thsOption.calcStrategyChartData(xml.join(''));
				}
			}else{
				// alert(321)
				// alert(me.domXMl)
				// alert(xml.join(''))
				rlt = thsOption.calcStrategyChartData(xml.join(''));
			}
			me.domXMl = xml.join('');
			if(rlt){ // 计算错误
				me.showError(rlt);
				// alert('计算错误----------------'+rlt)
			}else{
				var $gns = $ss.find('td[gn=' + gn + ']');
				var code = $ss.find('td[gn=' + gn + '].bg53').attr('code');
				// alert( $gns.length)
				// alert($.toJSON(Global.selCode[Global.domName][cow-1])+'--'+cow+'--'+code)
				try{				
					// var domIndex = Global.selCode[Global.domName][cow-1];
					// alert(row)
					Global.selCode[Global.domName][cow-1] = row;
				}catch(e){
					// alert('设置2---------'+$.toJSON(e))
				}
				//var idx = $rows.index($el);
				$gns.removeClass('bg53');
				
				for(var i=0; i<5; i++){
					$gns.eq(row*5 + i).addClass('bg53');
				}
				// if(this.sltName){
					// if(Global.selCode[Global.code+'_'+this.strategyid+'_'+this.sltName]){
						// selCode = Global.selCode[Global.code+'_'+this.strategyid+'_'+this.sltName];
					// }else{
						// Global.selCode[Global.code+'_'+this.strategyid+'_'+this.sltName] = selCode;
					// }
				// }
			}
			}catch(e){
				// alert('图像-------------'+$.toJSON(e))
				
			}
		});
		// 切换月份（多到期日组合）
		$base.on('change', '.strategies thead select', function(e) {
			// 判断日期是否符合规则
			if (cout != 0){
				return;
			}
			var od = this.getAttribute('cd'); // 原始值
			var nd = this.value; // 当前值
			var odt = od.charAt(od.length - 1); // 原始到期日类型，是否除权
			var ndt = nd.charAt(nd.length - 1); // 当前到期日类型，是否除权
			var $s = $(this);
			this.sltName = $s.val();
			var $th = $s.parent();
			var $tr = $th.parent();
			var idx = $th.index(); // 当前组合顺序
			var rule = me.config.dateRule[idx]; // 当前组合选择规则基数
			var dsArr = []; // 选中到期日
			var dsMap = {}; // 选中到期日Map（需要变更的到期日，对应组合顺序）
			dsMap[idx] = nd;
			
			for(var i=0; i<me.config.dateRule.length; i++){
				if(i == idx){ // 跳过自身
					dsArr.push(nd);
					continue;
				}
				var ir = me.config.dateRule[i]; // 当前组合选择规则基数
				var $is = $tr.find('select').eq(i);
				var id = $is.val(); // 到期日
				var idt = id.charAt(id.length - 1); // 到期日类型，是否除权
				if(ir == rule){ // 相同到期日
					dsArr.push(nd);
					dsMap[i] = nd;
					continue;
				}else if(((ir > rule && id > nd) || (ir < rule && id < nd)) && idt == ndt){ // 不同到期日，基数比和日期比方向相同，并且到期类型相同
					dsArr.push(id);
					continue;
				}else{
					for(var j=0; j<me._dates.length; j++){
						var jd = me._dates[j];
						var jdt = jd.charAt(jd.length - 1); // 到期日类型，是否除权
						if(((ir > rule && jd > nd) || (ir < rule && jd < nd)) && jdt == ndt){ // 不同到期日，基数比和日期比方向相同，并且到期类型相同
							dsArr.push(jd);
							dsMap[i] = jd;
							break;
						}
					}
				}
			}
			// 处理结果
			// alert(dsArr.length+'----------'+me.config.total)
			if(dsArr.length == me.config.total){ // 出现符合日期选择规则的组合
				for(var i in dsMap){
					$tr.find('select').eq(i).val(dsMap[i]).attr('cd', dsMap[i]); // 更新文档节点
				}
				// alert($.toJSON(dsMap))
				me.updateMultiple(dsArr, dsMap, true); // 不会触发change事件
				// me.updateMultiple(dsArr, {}); // 不会触发change事件
			}else{
				$s.val(od); // 回退选项
			}
		});
		
		// 改变合约单位份额
		$amount.on('blur', function(e, n) {
			// if (cout != 0){
				// return;
			// }
			var oval = this.getAttribute('oval');
			var reg = /\D/g;
			try{
				var match = reg.test(this.value);
				// alert(match)
				if(match){
					this.value = 1
				}
			}catch(e){
				// alert($.toJSON(e))
			}
			var n = parseInt(n) || 0;
			var num = parseInt(this.value) + n;
			this.value = (num > 0 ? num : 1);
			if(this.value == oval){ // 值未改变
				return;
			}
			this.setAttribute('oval', this.value);
			
			if(me.config.total == 1){ // 单合约组合触发计算
				$base.find('.sbg53').addClass('feChange').removeClass('sbg53').click();
			}else{ // 多合约组合触发计算
				var $ss = $('.strategies');
				var $el = $ss.find('td.bg53').eq(0);
				var gn = $el.attr('gn');
				var row = $el.parent().index();
				var $gns = $ss.find('td[gn=' + gn + ']');
				// 判断当前选中数是否符合计算准备
				if( $ss.find('td.bg53').length/5 != me.config.total ){ // 不满足多个合约选中
					return;
				}else{
					$gns.removeClass('bg53');
					$el.addClass('feChange').click();
				}
			}
		});
		// 份额减一
		$('.up').on('click', function(e) {
			// if (cout != 0){
				// return;
			// }
			$amount.trigger('blur', [1]);
		});
		// 份额加一
		$('.down').on('click', function(e) {
			// if (cout != 0){
				// return;
			// }
			$amount.trigger('blur', [-1]);
		});
	
      		// 下单
		$(this.orderCls).on('click', function(e) {
			var xml = [
				'<?xml version="1.0" encoding="GB2312"?>',
				'<calc_param>',
					'<target market="', me.market, '" code="', me.code, '" nprice="', me.now, '"/>',
					'<option>'];
			if(me.config.total == 1){ // 单合约组合触发下单
				var $opt = $base.find('.sbg53');
				if($opt.length != me.config.total){ // 未选中合约
					return;
				}
				var $tds = $opt.find('td');
				var amount = $amount.val();
				xml.push('<item code="', $tds.eq(0).attr('code'), 
							'" type="', $tds.eq(0).attr('type'), 
							'" trade="', $tds.eq(0).attr('trade'), 
							'" cdate="', $tds.eq(0).attr('date'),
							'" cprice="', $tds.eq(0).text(), 
							'" nprice="', $tds.eq(2).text(), 
							'" buy="', $tds.eq(3).text(), 
							'" sell="', $tds.eq(4).text(), 
							'" vol="', $tds.eq(1).text()*amount, 
							'"/>');
			}else{ // 多合约组合触发计算
				var $opts = $base.find('td.bg53');
				if($opts.length/5 != me.config.total){ // 选中合约数不符合要求
					return;
				}
				var amount = $amount.val();
				for(var i=0; i<me.config.total; i++){
					xml.push('<item code="', $opts.eq(i*5).attr('code'), 
							'" type="', $opts.eq(i*5).attr('type'), 
							'" trade="', $opts.eq(i*5).attr('trade'), 
							'" cdate="', $opts.eq(i*5).attr('date'),
							'" cprice="', $opts.eq(i*5).text(), 
							'" nprice="', $opts.eq(i*5 + 2).text(), 
							'" buy="', $opts.eq(i*5 + 3).text(), 
							'" sell="', $opts.eq(i*5 + 4).text(), 
							'" vol="', $opts.eq(i*5 + 1).text()*amount, 
							'"/>');
							//alert(xml);
				}
			}
			xml.push('</option>',
				'</calc_param>');
			log.log('下单：' + xml.join(''));
			thsOption.callxiadan(xml.join('')); // 下单
		});
	},
	
	_request: function(){
		var me = this;
		// alert(Global.setCode)
		// if(Global.setCode){
		// }else{
			// alert('设置----------'+this.code+'-----------'+this.market)
			// 获取期权信息及策略信息
			thsOption.regOptionCallBack({
				code: this.code,
				market: this.market,
				func: function(xml){
				// alert(xml)
					Global.setCode = true;
					me.optionCallback(xml);
				}
			});
		// }
		if(Global.debug){
			var xml = '<option_param market="17" code="600104"  nprice="9.70" rise="0.29" gains="0.29%">' + 
					//'<strategy optionnum="1" optionhead="00" ratio="1" cdates="1" defcode="?HKLI" defdate="20140615M" push="0"/>' + 
					//'<strategy coustom=1  optionnum="4" optionhead="00-10-01-11" ratio="1:2:3:1" cdates="1:2:1:2" defcode="?HALI:?HKC1:?HKL2:?HKA3" defdate="20140615M:20140915M:20140615M:20140915M" push="0"/>' + 
					'<strategy coustom="1" optionnum="4" optionhead="00-10-01-11" ratio="1:2:3:1" cdates="1:2:1:2" defcode="?HALI:?HKC1:?xxxxx:?HKA3" defdate="20140615M:20140915M:20140615M:20140915M" push="0"/>' + 
					'<cdate val="20140615" type="M">' + 
						'<info type="0">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKLG" preclose="9.90"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?HKLH" preclose="9.90"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKLI" preclose="9.90"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HALI" preclose="9.90"/>' + 
						'</info>' + 
						'<info type="1">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKL1" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?HKL2" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKL3" preclose="9.30"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAL2" preclose="9.90"/>' + 
						'</info>' + 
					'</cdate>' + 
					'<cdate val="20140615" type="A">' + 
						'<info type="0">' + 
							'<item cprice="187.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKL4" preclose="9.30"/>' + 
							'<item cprice="188" nprice="9.71" buy="9.50" sell="9.80" code="?HKL5" preclose="9.30"/>' + 
							'<item cprice="188.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKL5" preclose="9.30"/>' + 
							'<item cprice="189" nprice="9.71" buy="9.50" sell="9.80" code="?HAL3" preclose="9.90"/>' + 
						'</info>' + 
						'<info type="1">' + 
							'<item cprice="188" nprice="9.70" buy="9.50" sell="9.80" code="?HKL6" preclose="9.30"/>' + 
							'<item cprice="188.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKL7" preclose="9.30"/>' + 
							'<item cprice="189" nprice="9.71" buy="9.50" sell="9.80" code="?HKL8" preclose="9.30"/>' + 
							'<item cprice="189.5" nprice="9.71" buy="9.50" sell="9.80" code="?HAL4" preclose="9.90"/>' + 
						'</info>' + 
					'</cdate>' + 
					'<cdate val="20140915" type="M">' + 
						'<info type="0">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKA0" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?HKA1" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKC1" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAL5" preclose="9.90"/>' + 
						'</info>' + 
						'<info type="1">' + 
							'<item cprice="186" nprice="9.70" buy="9.50" sell="9.80" code="?HKA2" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKA3" preclose="9.30"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HKC2" preclose="9.80"/>' + 
							'<item cprice="187.5" nprice="9.71" buy="9.50" sell="9.80" code="?HAL6" preclose="9.90"/>' + 
						'</info>' + 
					'</cdate>' + 
					'<cdate val="20140915" type="A">' + 
						'<info type="0">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKA4" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?HKA5" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKC3" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAL7" preclose="9.90"/>' + 
						'</info>' + 
						'<info type="1">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKA6" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?HKA7" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKC4" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAL8" preclose="9.90"/>' + 
						'</info>' + 
					'</cdate>' + 
					'<cdate val="20141115" type="A">' + 
						'<info type="0">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKA8" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?HKA9" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKC5" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAL9" preclose="9.90"/>' + 
						'</info>' + 
						'<info type="1">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKB0" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?HKB1" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKC6" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAL0" preclose="9.90"/>' + 
						'</info>' + 
					'</cdate>' + 
					'<cdate val="20141115" type="M">' + 
						'<info type="0">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKA8" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?HKA9" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKC5" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAB0" preclose="9.90"/>' + 
						'</info>' + 
						'<info type="1">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKB0" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?HKB1" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKC6" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAB1" preclose="9.90"/>' + 
						'</info>' + 
					'</cdate>' + 
					'<cdate val="20141215" type="A">' + 
						'<info type="0">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKA8" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?HKA9" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKC5" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAB2" preclose="9.90"/>' + 
						'</info>' + 
						'<info type="1">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKB0" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?HKB1" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?HKC6" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAB3" preclose="9.90"/>' + 
						'</info>' + 
					'</cdate>' + 
					'<cdate val="20141215" type="M">' + 
						'<info type="0">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?MKA8" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?MKA9" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?MKC5" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAB4" preclose="9.90"/>' + 
						'</info>' + 
						'<info type="1">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?MKB0" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?MKB1" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?MKC6" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAB5" preclose="9.90"/>' + 
						'</info>' + 
					'</cdate>' + 
					'<cdate val="20140803" type="M">' + 
						'<info type="0">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?M8A8" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?M8A9" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?M8C5" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAB6" preclose="9.90"/>' + 
						'</info>' + 
						'<info type="1">' + 
							'<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?M8B0" preclose="9.30"/>' + 
							'<item cprice="186" nprice="9.71" buy="9.50" sell="9.80" code="?M8B1" preclose="9.30"/>' + 
							'<item cprice="186.5" nprice="9.71" buy="9.50" sell="9.80" code="?M8C6" preclose="9.80"/>' + 
							'<item cprice="187" nprice="9.71" buy="9.50" sell="9.80" code="?HAB7" preclose="9.90"/>' + 
						'</info>' + 
					'</cdate>' + 
				'</option_param>';
			this.optionCallback(xml);
		}
	},
	//股票信息实时刷新
	refresCode : function(data){
		var $base = $('.head');
		var num = 2;
		num = (data.market == 20) ? 3 : 2;//市场号为20则是3为小数
		$base.find('.now').text(parseFloat(data.nprice, 10).toFixed(num));
		$base.find('.val').text(parseFloat(data.rise, 10).toFixed(num));
		$base.find('.pos').text(parseFloat(data.gains, 10).toFixed(2) + '%');
		// alert($base.html())
		if(data.rise > 0){
			// $base.find('.now').attr('class', 'now red');
			$base.find('.val').attr('class', 'val red');
			$base.find('.pos').attr('class', 'pos red');
		}else if(data.rise < 0){
			// $base.find('.now').attr('class', 'now green');
			$base.find('.val').attr('class', 'val green');
			$base.find('.pos').attr('class', 'pos green');
		}
	},
	/*
	 * 获取期权、策略及选择规则
	 * @param xml String
	 *	<option_param market="17" code="600000" nprice="9.70" rise="0.29" gains="0.29%">
	 *		<!--
	 *		策略信息
	 *		optionnum: 组合数量
	 *		optionhead: 组合顺序 -分割，首位含义：0->买入 1->卖出；第二位：0->看涨（认购） 1->看跌（认沽）。例，买入看涨即为00
	 *		ratio: 组合中合约数量比例
	 *		cdates: 组合到期日选择规则 1序列的到期日必须大于0序列，相同值序列的日期值必须相同
	 *		defcode: 默认选中的合约代码
	 *		defdate: 默认选中组合的日期
	 *		push: 当前数据是否为推送数据（更新）
	 *		-->
	 *		<strategy optionnum="4" optionhead="00-01-10-11" ratio="1:2:3:1"  cdates="1:2:1:2" push="0"/>
	 *		<!-- val:到期日 type:M 表示未除权, A 表示已除权 -->
	 *		<cdate val="20140615" type="M">
	 *			<!-- type 0:看涨（认购） 1:看跌（认沽） -->
	 *			<info type="0">
	 *				<!-- cprice:行权价 nprice:最新价 buy:买价 sell:卖价 code:期权代码 preclose:昨收价-->
	 *				<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKLG" preclose="9.30"/>
	 *				<item cprice="186.00" nprice="9.71" buy="9.50" sell="9.80" code="?HKLF" preclose="9.30"/>
	 *			</info>
	 *			<info type="1">
	 *				<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKLG" preclose="9.30"/>
	 *				<item cprice="186.00" nprice="9.71" buy="9.50" sell="9.80" code="?HKLF" preclose="9.30"/>
	 *			</info>
	 *		</cdate>
	 *		<cdate val="20140615" type="A">
	 *			<info type="0">
	 *				<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKLG" preclose="9.30"/>
	 *				<item cprice="186.00" nprice="9.71" buy="9.50" sell="9.80" code="?HKLF" preclose="9.30"/>
	 *			</info>
	 *			<info type="1">
	 *				<item cprice="185.5" nprice="9.70" buy="9.50" sell="9.80" code="?HKLG" preclose="9.30"/>
	 *				<item cprice="186.00" nprice="9.71" buy="9.50" sell="9.80" code="?HKLF" preclose="9.30"/>
	 *			</info>
	 *		</cdate>
	 *	</option_param>
	 */
	optionCallback: function(xml){
		try{
			var data = $.xml2json(xml);
			log.log(data);
			// alert($.toJSON(data))
			// alert(xml)
			this.code = data.code;
			this.market = data.market;
			// this.name = data.name;
			this.name = data.strategy.coustomname;
			this.now = data.nprice;
			this.rise = data.rise;
			this.gains = data.gains;
			// this.config={};		
			if(data.strategy.push == '1'){
			}else{				
				// alert(xml)	
				Global.selCode={};
			}
			// alert(data.strategy.modifyparam)
			if(data.strategy.modifyparam && data.strategy.modifyparam == 1){
				$('.foot').find('.utext2').show();
			}else{
				$('.foot').find('.utext2').hide();
			}
			data.strategy.coustomname = data.strategy.coustomname || "";
			this._dates = [];
			// alert(this.code);
			try{
			if(this.code){
				this.refresCode(data);
				// alert(this.strategyid +'-----------'+ data.strategy.strategyid)
				if(this.strategyid){
				// alert(this.strategyid +'-----------'+ data.strategy.strategyid)
					// alert(this.strategyid+'---------'+data.strategy.coustomname)
					if(data.strategy.strategyid == -2){
					// alert((this.strategyid +'-----'+ (data.strategy.coustomname+data.strategy.strategyid)))
						if(this.strategyid != (data.strategy.coustomname+data.strategy.strategyid)){// && this.strategyid && this.strategyid != data.strategyid){
							$('.amount').val(1);
							// Global.selCode0 = "";
							Global.selCode[Global.code+'_'+this.strategyid] = "";
							this.strategyid = (data.strategy.coustomname+data.strategy.strategyid) || "";
							Global[this.strategyid] = data.strategy.ratio;
							// alert(this.strategyid)
						}
					}else{
						if(this.strategyid != data.strategy.strategyid){// && this.strategyid && this.strategyid != data.strategyid){
							// Global.selCode0 = "";
							Global.selCode[Global.code+'_'+this.strategyid] = "";							
							$('.amount').val(1);
							this.strategyid = data.strategy.strategyid || "";
						}
					}
				}else{
					data.strategy.strategyid = (data.strategy.strategyid == -2)?data.strategy.coustomname+data.strategy.strategyid : data.strategy.strategyid;
					$('.amount').val(1);
					this.strategyid = data.strategy.strategyid || "";
					Global[this.strategyid] = data.strategy.ratio;
				}
			}
			}catch(e){
				// alert('str--------------'+$.toJSON(e))	
					
			}
		
			var cfg = data.strategy;
			// alert($.toJSON(cfg.ratio))
			this.config.total = (cfg.optionnum || '1');
			this.config.tOrder = (cfg.optionhead || '00').split('-');
			this.config.numRatio = (cfg.ratio || '1').split(':');
			this.config.dateRule = (cfg.cdates || '0').split(':');
			this.config.defcode = (cfg.defcode || '').split(':');
			this.config.defdate = (cfg.defdate || this.config.defdate.join(':') || "").split(':');
			this.config.push = (cfg.push || '0');
			this.config.coustom = (cfg.coustom || '0');
		//	alert("ff");
			 //alert(this.config.coustom )
			Global.coustom = this.config.coustom;
		  if (this.config.coustom == '1'){
			// $('.strategy thead select').attr('disabled',true);
			try{
			$('#mcode').attr('disabled',true);
			   cout = 1;
			 var biaodi = document.getElementById('mcode');
			 var biaodi2= $('#mcode');
			  var len = biaodi.options.length;
			  var i = 0;
			  var j = 0;
			  for (i=0;i<len;i++){
				//  alert(biaodi.options[i].value+'----------'+this.code +'----------'+ biaodi.options[i].getAttribute('market')+'---------'+this.market)
				if (biaodi.options[i].value == this.code && biaodi.options[i].getAttribute('market') == this.market){
						j++;
				//alert( biaodi.options[i].value);
				 biaodi.options[i].selected=true;
				 break;
				}
			  }
			  }catch(e){
				// alert('biaodi----------'+$.toJSON(e))
			  }
			  if (j==0){
				// alert("该代码没有对应的标的名称！");
			  }
			  
			 //  $('#mcode').append('<option '+'market=' + this.market + 'code=' + this.code + 'name=' + this.name +'>'+ this.name + '&nbsp' +this.code +'</option>');
		//   biaodi.options[0].value = this.code;
			   //biaodi.options[0].market = this.market;
			  // this._bindEvent();
			}
			else {
			$('#mcode').attr('disabled',false);
			   cout = 0;
			  // this._bindEvent();
			}
			
			var fmtD = {};
			var dinfo = [].concat(data.cdate || []);
			for(i=0; i<dinfo.length; i++){
				var key, cdate = dinfo[i],
					ops = [];
				key = cdate.val + cdate.type;
				var info0 = [].concat(cdate.info[0].item || []);
				var info1 = [].concat(cdate.info[1].item || []);
				var map0 = {}, map1 = {}, j;
				for(j=0; j<info0.length; j++){
					map0[info0[j].cprice] = info0[j];
				}
				for(j=0; j<info1.length; j++){
					map1[info1[j].cprice] = info1[j];
				}
				fmtD[key] = {
					'0': info0,
					'1': info1,
					'map0': map0,
					'map1': map1,
					'date': cdate.val,
					'title': this.formatDate(cdate.val),
					'type': cdate.type,
					'key': cdate.val + cdate.type
				};
				this._dates.push(key);
			}
			// alert($.toJSON(this._dates))
			this._d2ops = fmtD;
			this._dates.sort(); // 排序
		
			// alert($.toJSON(this.config))
			try{
				// alert(this.config.push+'--------'+this.config.total)
				if(this.config.push == '1'){ // 数据更新
					if(this.config.total == 1){ // 单合约
						this.updateSignle();
					}else{ // 多合约
						this.updateMultiple();
					}
					return;
				}
				// 整体渲染
				if(this.config.total == 1){ // 单合约
					this.renderSignle();
				}else{ // 多合约
					this.renderMultiple();
				}
			
			}catch(e){ 
				log.log(e); 
				// alert('render------------'+$.toJSON(e))
			}
			if (this.config.coustom == '1'){
				$('.strategy thead select').attr('disabled',true);
				$('.strategies thead select').attr('disabled',true);
			}
			$('.loadingtext').hide();
			$('.loading').hide();
		}catch(e){
			log.log(e); 
			// alert('total---------'+$.toJSON(e))
		}
	},
	/*
	 * 切换标的
	 * @param cfg Object
	 * 	|- code String 代码
	 * 	|- market String 市场
	 * 	|- now String 现价
	 * 	|- rise String 涨跌
	 * 	|- gains String 涨幅
	 */
	changeCode: function(cfg){
	 // if (cout != 0){
				// return;
			// }
		if(cfg.code == this.code){
		}else{
			$(this.baseCls).empty();			
		}
		this.code = cfg.code;
		this.market = cfg.market;
		this.now = cfg.now;
		this.rise = cfg.rise;
		this.gains = cfg.gains;
		// $(this.baseCls).empty();
		// alert('change')
		this._request();
	},
	/*
	 * 获取合约标题
	 * @param sign String 代码
	 * 	|- 首位含义：0->买入 1->卖出；第二位：0->看涨（认购） 1->看跌（认沽）。例00，即买入看涨。
	 * @return String
	 */
	getTitle: function(sign){
		if(!sign){
			return 'NULL';
		}
		return this._ohmap[sign] || 'NULL';
	},
	/*
	 * 比较两个数的大小
	 * @param sign String 数字格式日期20140508
	 * @return String red/green
	 */
	getColor: function(num1, num2){
		
		num1 = parseFloat(num1);
		num2 = parseFloat(num2);
		// if(cout == 1){
			// alert(num1+'----------'+num2+'=--------------'+(num1 > num2))
		// }
		if(num1 > num2){
			return 'red';
		}else if(num1 < num2){
			return 'green';
		}else{
			return '';
		}
	},
	/*
	 * 格式化日期年月
	 * @param sign String 数字格式日期20140508
	 * @return String 2014年5月
	 */
	formatDate: function(num){
		return num.substr(0, 4) + '年' + parseInt(num.substr(4, 2), 10) + '月';
	},
	// 渲染单合约
	renderSignle: function(){
		var key, i, rise, dealCls, html,
			cfg = this.config,
			me = this;
		// alert($.toJSON(this.config))
		key = cfg.defdate[0];
		html = [
			'<table class="strategy">',
				'<thead class="duedate">',
					'<tr>',
						'<th colspan=11>', this.getTitle(cfg.tOrder[0]), '合约：',
							'<select>'
		];
		for(i=0; i<this._dates.length; i++){
			var id2o = this._d2ops[this._dates[i]];
			html.push(			'<option value="', id2o.key, '"', (id2o.key == key ? ' selected="selected"' : ''), '>', id2o.title, '(', id2o.type, ')</option>');
		}
		html.push(			'</select>',
						'</th>',
					'</tr>',
				'</thead>',
				'<thead class="sort">',
					'<tr>',
						'<th class="bg26">执行权</th>',
						'<th>数量</th>',
						'<th>最新</th>',
						'<th>买价</th>',
						'<th>卖价</th>',
						'<th>隐含波动率</th>',
						'<th>Delta</th>',
						'<th>Gamma</th>',
						'<th>Theta</th>',
						'<th>Vega</th>',
						'<th>Rho</th>',
					'</tr>',
				'</thead>',
				'<tbody>');
					
		rise = cfg.tOrder[0].charAt(1); // 看涨看跌（认购认沽）代码
		// dealCls = cfg.tOrder[0].charAt(0) == 0 ? 'red' : 'green';
		dealCls = 'blue';
		// alert(key+'---------'+$.toJSON(this._d2ops[key]))
		for(i=0; i<this._d2ops[key][rise].length; i++){
			var cdate = this._d2ops[key];
			// alert($.toJSON(cdate))
			var opt = cdate[rise][i];
			var optex = {
				cprice: opt.cprice,
				nprice: opt.nprice,
				//date: cdate.date,
				date: cdate.key,
				type: rise,
				trade: cfg.tOrder[0].charAt(0)
			}
			this.calcTipInfo(optex); // 通过calcTipInfo方法扩展了od的属性
			// alert($.toJSON(opt))
			// var bcolor = this.getColor(opt.sell, opt.preclose);
			var ncolor = this.getColor(opt.nprice, opt.preclose);
			var bcolor = this.getColor(opt.buy, opt.preclose);
			var scolor = this.getColor(opt.sell, opt.preclose);
			// var scolor = this.getColor(opt.sell, opt.preclose);
			var defed = cfg.defcode[0].indexOf(opt.code) > -1;
			var name = this._d2ops[this._dates[0]].title+'('+this._d2ops[this._dates[0]].type+')';
			if(defed){//选中
			// alert(Global.code+'_'+this.strategyid+'_'+name)
				Global.selCode[Global.code+'_'+this.strategyid+'_'+name] = i;
				Global.selCode0[Global.code+'_'+this.strategyid+'_'+name] = i;
				Global.domName = Global.code+'_'+this.strategyid+'_'+name;
			}
			html.push('<tr', (defed ? ' class="sbg53"':''), '>',
						'<td class="bg26 ', dealCls, '" code="', opt.code, '" type="', optex.type, '" trade="', optex.trade, '" date="', optex.date, '">', parseFloat(opt.cprice, 10).toFixed(4), '</td>',
						'<td>', cfg.numRatio[0], '</td>',
						'<td', (ncolor ? ' class="' + ncolor + '"' : ''), '>', parseFloat(opt.nprice, 10).toFixed(4), '</td>',
						'<td', (bcolor ? ' class="' + bcolor + '"' : ''), '>', parseFloat(opt.buy, 10).toFixed(4), '</td>',
						'<td', (scolor ? ' class="' + scolor + '"' : ''), '>', parseFloat(opt.sell, 10).toFixed(4), '</td>',
						'<td class="',this.getColor(optex.yhbdl, 0),'">', parseFloat(optex.yhbdl, 10).toFixed(4), '</td>',
						'<td class="',this.getColor(optex.delta, 0),'">', parseFloat(optex.delta, 10).toFixed(4), '</td>',
						'<td class="',this.getColor(optex.gamma, 0),'">', parseFloat(optex.gamma, 10).toFixed(4), '</td>',
						'<td class="',this.getColor(optex.theta, 0),'">', parseFloat(optex.theta, 10).toFixed(4), '</td>',
						'<td class="',this.getColor(optex.vega, 0),'">', parseFloat(optex.vega, 10).toFixed(4), '</td>',
						'<td class="',this.getColor(optex.rho, 0),'">', parseFloat(optex.rho, 10).toFixed(4), '</td>',
					'</tr>');
		}
		html.push('</tbody>',
			'</table>');
		$(this.baseCls).html(html.join(''));
	},
	// 渲染多合约
	renderMultiple: function(){
		var i, j, html,
			cfg = this.config,
			me = this;
		
		// log.log(cfg);
		// log.log(this._d2ops);
		// alert('cfg------------'+$.toJSON(cfg))
		// alert('_d2ops------------'+$.toJSON(this._d2ops))
		// alert('_dates---------'+$.toJSON(this._dates))
		html = [
			'<table class="strategies">',
				'<thead class="duedate">',
					'<tr>'
		];
		// 到期日
		for(i=0; i<cfg.total; i++){
		// alert(this.getTitle(cfg.tOrder[i]))
			html.push(	'<th colspan=5', (i == cfg.total-1 ? '':' class="br3"'), '>', this.getTitle(cfg.tOrder[i]), '合约：', 
							'<select cd="', cfg.defdate[i], '">');
			for(j=0; j<this._dates.length; j++){
				var id2o = this._d2ops[this._dates[j]] ?this._d2ops[this._dates[j]]:{};
				html.push(		'<option value="', id2o.key, '"', (id2o.key==cfg.defdate[i] ? ' selected="selected"':''), '>', id2o.title, '(', id2o.type, ')</option>');
			}
			html.push(		'</select>',
						'</th>');
		}
		html.push(	'</tr>',
				'</thead>',
				'<thead class="sort">',
					'<tr>');
		// 表头
		for(i=0; i<cfg.total; i++){
			html.push(	'<th class="bg26">执行权</th>',
						'<th>数量</th>',
						'<th>最新</th>',
						'<th>买价</th>',
						'<th', (i == cfg.total-1 ? '':' class="br3"'), '>卖价</th>');
		}
		html.push(	'</tr>',
				'</thead>',
				'<tbody>');
		
		// 统计行权价集合
		try{
			var oppris = [];
			for(i=0; i<cfg.total; i++){
				var rise = cfg.tOrder[i].charAt(1); // 看涨看跌（认购认沽）代码
				var idt = cfg.defdate[i]; // 到期日
				var opts = this._d2ops[idt]?this._d2ops[idt][rise]:[]; // 合约集合
				if(opts &&opts!='undefined'&& opts.length>0){
					for(j=0; j<opts.length; j++){
						var opt = opts[j];
						if(oppris.join('|').indexOf(opt.cprice) == -1){
							oppris.push(opt.cprice);
						}
					}
				}
			}
		}catch(e){
			// alert($.toJSON(cfg))
			// alert($.toJSON(e))
			
		}
		function sortNumber(a,b) 
		{ 
		return a - b 
		} 
		oppris.sort(sortNumber); // 从小到大排序
		// 合约信息
		for(i=0; i<oppris.length; i++){
			var fpri = oppris[i];
			
			html.push('<tr cow="'+i+'">');
			
			for(j=0; j<cfg.total; j++){
				var trade = cfg.tOrder[j].charAt(0); // 买入卖出代码
				var rise = cfg.tOrder[j].charAt(1); // 看涨看跌（认购认沽）代码
				// var dealCls = cfg.tOrder[j].charAt(0) == 0 ? 'red' : 'green';
				var dealCls = 'blue';
				var idt = cfg.defdate[j];
				var cdate = this._d2ops[idt];
				var priMap = cdate['map' + rise];
				var opt = priMap[fpri] || {};
				// alert($.toJSON(opt))
				if(!opt.code){ // 当前到期日无此行权价
					html.push(
						'<td gn="', j, '" class="bg26 ', dealCls, '">-</td>',
						'<td gn="', j, '">-</td>',
						'<td gn="', j, '">-</td>',
						'<td gn="', j, '">-</td>',
						'<td gn="', j, '" class="', (j == cfg.total-1 ? '':'br3'), '">-</td>');
					continue;
				}
				var defed = cfg.defcode[j].indexOf(opt.code) > -1; // 是否默认选中
				var ncolor = this.getColor(opt.nprice, opt.preclose);
				var bcolor = this.getColor(opt.buy, opt.preclose);
				var scolor = this.getColor(opt.sell, opt.preclose);
				// var bcolor = this.getColor(opt.sell, opt.preclose);
				// var scolor = this.getColor(opt.sell, opt.preclose);
				//log.log([opt.code, cfg.defcode, cfg.defcode.indexOf(opt.code)]);
				html.push(
						'<td gn="', j, '" class="bg26 ', dealCls, (defed ? ' bg53':''),'" code="', opt.code, '" type="', rise, '" trade="', trade, '" date="', cdate.key, '">', parseFloat(opt.cprice, 10).toFixed(4), '</td>',
						'<td gn="', j, '" ', (defed ? 'class="bg53"':''), '>', cfg.numRatio[j], '</td>',
						'<td gn="', j, '" class="', (ncolor ? ncolor:''), ' ', (defed ? ' bg53':''), '">', parseFloat(opt.nprice, 10).toFixed(4), '</td>',
						'<td gn="', j, '" class="', (bcolor ? bcolor:''), ' ', (defed ? ' bg53':''), '">', parseFloat(opt.buy, 10).toFixed(4), '</td>',
						'<td gn="', j, '" class="', (scolor ? scolor : ''), ' ', (j == cfg.total-1 ? '':'br3'), ' ', (defed ? ' bg53':''), '">', parseFloat(opt.sell, 10).toFixed(4), '</td>');
			}
			html.push('</tr>');
		}
		html.push('</tbody>',
			'</table>');
		$(this.baseCls).html(html.join(''));
		
		var name = this._d2ops[this._dates[0]].title+'('+this._d2ops[this._dates[0]].type+')';
		this.sltName = name;
		var $base = $(this.baseCls);
		var $tby = $base.find('tbody');
		var selCode = {}; // 需要保留未更新的合约信息（合约代码、合约数量）
		var domIndex = {};
	   //$(".bg26").attr('disabled','disabled');
		for(var i=0; i<this.config.total; i++){
			selCode[i] = {};
			// if(nMap[i]){				
				// continue;
			// } 
			var $selopt = $tby.find('td[gn=' + i + ']');
			//alert($selopt.eq(0));
			for(var j=0; j<$selopt.length/5; j++){
				var $otdc = $selopt.eq(j*5);
				
				if(!$otdc.attr('code')){
					continue;
				}
				//alert($otdc.attr('code'))
				selCode[i][$otdc.attr('code')] = {};
				//selCode[$otdc.attr('code')]['num'] = $otdc.next().find('input').val();
				if($otdc.hasClass('bg53')){
					selCode[i][$otdc.attr('code')]['act'] = true;	
					domIndex[i] = j;
				}
				
			}
		}
		try{
			// alert($.toJSON(domIndex))
			if(Global.selCode[Global.code+'_'+this.strategyid]){
				// selCode = Global.selCode[Global.code+'_'+this.strategyid+'_'+name];
			}else{
				Global.selCode[Global.code+'_'+this.strategyid] = domIndex;
				var str = $.toJSON(domIndex);
				Global.selCode0[Global.code+'_'+this.strategyid] = eval('('+str+')');
			}
			Global.domName = Global.code+'_'+this.strategyid;
		}catch(e){
			// alert($.toJSON(e))
		}
		// alert($.toJSON(selCode)+'--------'+$.toJSON(Global.selCode))
	},
	/*
	 * 计算tip信息 获取期权-隐含波动率/Delta/Gamma/Theta/Vega/Rho
	 * @param cfg Object 期权参数
	 * 	|-cprice String 行权价
	 * 	|-nprice 最新价（期权）
	 * 	|-date 到期日
	 * 	|-type 看涨看跌（认购认沽）类型
	 * @return String 2014年5月
	 */
	calcTipInfo: function(cfg){
		log.log(cfg);
		var xml = thsOption.calcTipInfo({
			market: this.market, // 市场代码
			code: this.code, // 标的代码
			now: this.now, // 现价（标的）
			cprice: cfg.cprice, // 行权价
			nprice: cfg.nprice, // 最新价（期权）
			date: cfg.date, // 日期
			type: cfg.type // 看涨看跌（认购认沽）类型
		});
		if(Global.debug){
			xml = '<calc_result>' + 
				'<target market="17" code="600000"/>' + 
				'<result yhbdl="0.103" delta="64.41" gamma="26.69" theta="-13.92" vega="5.13" rho="5.13"/>' + 
			'</calc_result>';
		}
		var rlt = $.xml2json(xml).result;
		$.extend(cfg, rlt);
		return cfg;
	},
	// 重置tip
	resetTip: function(){
		//log.log(['resetTip', 'x', this._tact.x, 'y', this._tact.y]);
		clearTimeout(this._ttimer); // 中断计时
		$('.tip').hide(); // 隐藏
		this._tact.x = -1; // 重置
		this._tact.y = -1;
	},
	// 显示tip
	showTip: function(){
		log.log(['showTip!', this._txy]);
		var x, y,
			patch = 4, // 防滑补丁
			w = 182 + patch, // tip 宽
			h = 146 + patch, // tip 高
			ww = document.documentElement.clientWidth,
			wh = document.documentElement.clientHeight;
		x = this._txy.cx;
		y = this._txy.cy;
		if(ww - x < w){
			x -= w;
		}else{
			x += patch;
		}
		if(wh - y < h){
			y -= h;
		}else{
			y += patch;
		}
		this.calcTipInfo(this._tact); // 计算tip信息
		
		var $tip = $('.tip');
		$tip.find('tbody').html([
			'<tr>',
				'<td>隐含波动率</td>',
				'<td class="tar">', parseFloat(this._tact.yhbdl, 10).toFixed(4), '</td>',
			'</tr>',
			'<tr>',
				'<td>Delta</td>',
				'<td class="tar">', parseFloat(this._tact.delta, 10).toFixed(4), '</td>',
			'</tr>',
			'<tr>',
				'<td>Gamma</td>',
				'<td class="tar">', parseFloat(this._tact.gamma, 10).toFixed(4), '</td>',
			'</tr>',
			'<tr>',
				'<td>Theta</td>',
				'<td class="tar">', parseFloat(this._tact.theta, 10).toFixed(4), '</td>',
			'</tr>',
			'<tr>',
				'<td>Vega</td>',
				'<td class="tar">', parseFloat(this._tact.vega, 10).toFixed(4), '</td>',
			'</tr>',
			'<tr>',
				'<td>Rho</td>',
				'<td class="tar">', parseFloat(this._tact.rho, 10).toFixed(4), '</td>',
			'</tr>'].join(''));
		$tip.css({
			'left': x,
			'top': y
		}).show();
	},
	/*
	 * 更新数据 单合约组合
	 * @param key String 20140508A 月份变更
	 */
	updateSignle: function(nkey){
		var cfg = this.config;
		var rise = cfg.tOrder[0].charAt(1); // 看涨看跌（认购认沽）代码
		// var dealCls = cfg.tOrder[0].charAt(0) == 0 ? 'red' : 'green';
		var dealCls = 'blue';
		var $base = $(this.baseCls);
		var $tby = $base.find('tbody');
		var selIdx, html=[];
		// if(nkey){ // 变更月份
			// selIdx = -1;
		// }else{
			selIdx = $tby.find('.sbg53').index(); // 保存选中行
			if(Global.selCode[Global.code+'_'+this.strategyid+'_'+this.sltName]){
				// selIdx = Global.selCode0[Global.code+'_'+this.strategyid+'_'+this.sltName];
			}else{
				Global.selCode[Global.code+'_'+this.strategyid+'_'+this.sltName] = selIdx;
			}
		// }
		// alert(selIdx)
		var key = nkey || $base.find('.duedate select').val();
		
		for(i=0; i<this._d2ops[key][rise].length; i++){
			var cdate = this._d2ops[key];
			var opt = cdate[rise][i];
			var optex = {
				cprice: opt.cprice,
				nprice: opt.nprice,
				//date: cdate.date,
				date: cdate.key,
				type: rise,
				trade: cfg.tOrder[0].charAt(0)
			}
			this.calcTipInfo(optex); // 通过calcTipInfo方法扩展了od的属性
			// var bcolor = this.getColor(opt.sell, opt.preclose);
			var ncolor = this.getColor(opt.nprice, opt.preclose);
			var bcolor = this.getColor(opt.buy, opt.preclose);
			var scolor = this.getColor(opt.sell, opt.preclose);
			// var scolor = this.getColor(opt.sell, opt.preclose);
			html.push(
				'<tr class="', (i==selIdx ? 'sbg53':''), '">',
					'<td class="bg26 ', dealCls, '" code="', opt.code, '" type="', optex.type, '" trade="', optex.trade, '" date="', optex.date, '">', parseFloat(opt.cprice, 10).toFixed(4), '</td>',
					'<td>', cfg.numRatio[0], '</td>',
					'<td', (ncolor ? ' class="' + ncolor + '"' : ''), '>', parseFloat(opt.nprice, 10).toFixed(4), '</td>',
					'<td', (bcolor ? ' class="' + bcolor + '"' : ''), '>', parseFloat(opt.buy, 10).toFixed(4), '</td>',
					'<td', (scolor ? ' class="' + scolor + '"' : ''), '>', parseFloat(opt.sell, 10).toFixed(4), '</td>',
					'<td class="',this.getColor(optex.yhbdl, 0),'">', parseFloat(optex.yhbdl, 10).toFixed(4), '</td>',
					'<td class="',this.getColor(optex.delta, 0),'">', parseFloat(optex.delta, 10).toFixed(4), '</td>',
					'<td class="',this.getColor(optex.gamma, 0),'">', parseFloat(optex.gamma, 10).toFixed(4), '</td>',
					'<td class="',this.getColor(optex.theta, 0),'">', parseFloat(optex.theta, 10).toFixed(4), '</td>',
					'<td class="',this.getColor(optex.vega, 0),'">', parseFloat(optex.vega, 10).toFixed(4), '</td>',
					'<td class="',this.getColor(optex.rho, 0),'">', parseFloat(optex.rho, 10).toFixed(4), '</td>',
				'</tr>');
			
		}
		// alert(html.join(''))
		$tby.html(html.join(''));
		
		if(nkey){
			// alert(nkey+Global.code+'_'+this.strategyid+'_'+this.sltName)
			var index = Global.selCode0[Global.code+'_'+this.strategyid+'_'+this.sltName]
			// alert(index);
			$base.find('.strategy tbody tr').eq(index).click();
		}
	},
	/*
	 * 更新数据 多合约组合
	 * @param key Array [ 20140508A, 20140608A, 20140808A, 20140808A ]月份变更
	 * @param key Array { 0:20140508A, 3:20140608A } 需要变更的到期日，对应组合顺序
	 */
	updateMultiple: function(nkey, nMap, cBool){
		try{
		// log.log(['updateMultiple', $.toJSON(nkey), $.toJSON(nMap)]);
		//alert(cout);
		// alert($.toJSON(nkey)+'----------'+ $.toJSON(nMap));
		var $base = $(this.baseCls);
		var $tby = $base.find('tbody');
		// alert($tby.html())
		var nMap = nMap || {};
		var selCode = {}; // 需要保留未更新的合约信息（合约代码、合约数量）
		var domIndex = {};
	   //$(".bg26").attr('disabled','disabled');
	  
		for(var i=0; i<this.config.total; i++){
			selCode[i] = {};
			if(nMap[i]){				
				//selCode[i][$otdc.attr('code')] = {};
				// continue;
			} 
			var $selopt = $tby.find('td[gn=' + i + ']');
			//alert($selopt.eq(0)); 
			// alert($selopt.length/5)
			var len = $selopt.length/5;
			for(var j=0; j<len; j++){
				
				var $otdc = $selopt.eq(j*5);
				
				if(!$otdc.attr('code')){
					continue;
				}
				//alert($otdc.attr('code'))
				selCode[i][$otdc.attr('code')] = {};
				//selCode[$otdc.attr('code')]['num'] = $otdc.next().find('input').val();
				if($otdc.hasClass('bg53')){
					selCode[i][$otdc.attr('code')]['act'] = true;
					domIndex[i] = j;	
				}
				
			}
		}
		// alert($.toJSON(domIndex))
		try{
			if(this.sltName){
				if(cBool){
				}else{
					if(Global.selCode[Global.code+'_'+this.strategyid]){
						// selCode = Global.selCode[Global.code+'_'+this.strategyid+'_'+this.sltName];
					}else{
						Global.selCode[Global.code+'_'+this.strategyid] = domIndex;
					}
				}
			}
		}catch(e){
			// alert('aa-------'+$.toJSON(e))
		}
		// alert(this.sltName+'--------'+$.toJSON(selCode)+'--------'+$.toJSON(Global.selCode))
		var i, j, html = [],
			cfg = this.config,
			dkey = nkey,
			me = this;
			
		if(!dkey){ // 当前执行到期日组合
			dkey = [];
			var $dts = $base.find('.duedate select');
			for(var i=0; i<this.config.total; i++){
				dkey.push($dts.eq(i).val());
			}
		}
		// 统计行权价集合
		var oppris = [];
		for(i=0; i<cfg.total; i++){
			var rise = cfg.tOrder[i].substr(1); // 看涨看跌（认购认沽）代码
			var idt = dkey[i]; // 到期日
			var opts = this._d2ops[idt] ? this._d2ops[idt][rise]:[]; // 合约集合
			if(opts && opts!='undefined' &&opts.length>0){
				for(j=0; j<opts.length; j++){
					var opt = opts[j];
					if(oppris.join('|').indexOf(opt.cprice) == -1){
						oppris.push(opt.cprice);
					}
				}
			}
		}
		function sortNumber(a,b) 
		{ 
		return a - b 
		} 
		oppris.sort(sortNumber); // 从小到大排序
		// alert($.toJSON(oppris))
		// 合约信息
		var arr = Global.selCode[Global.code+'_'+this.strategyid];
		for(i=0; i<oppris.length; i++){
			var fpri = oppris[i];
			
			html.push('<tr>');
			// alert($.toJSON(cfg.total))
			for(j=0; j<cfg.total; j++){
				var trade = cfg.tOrder[j].charAt(0); // 买入卖出代码
				var rise = cfg.tOrder[j].charAt(1); // 看涨看跌（认购认沽）代码
				// var dealCls = cfg.tOrder[j].charAt(0) == 0 ? 'red' : 'green';
				var dealCls = 'blue';
				var idt = dkey[j];
				var cdate = this._d2ops[idt];
				var priMap = cdate['map' + rise];
				var opt = priMap[fpri] || {};//priMap[fpri] || {};
				
				if(!opt.code){ // 当前到期日无此行权价
					html.push(
						'<td gn="', j, '" class="bg26 ', dealCls, '">-</td>',
						'<td gn="', j, '">-</td>',
						'<td gn="', j, '">-</td>',
						'<td gn="', j, '">-</td>',
						'<td gn="', j, '" class="', (j == cfg.total-1 ? '':'br3'), '">-</td>');
					continue;
					
				}
				try{
				if(i==0){
					// alert($.toJSON(arr))
					// alert(arr[0]+'--'+(cfg.total-1)+'-'+arr[cfg.total-1])
					if((oppris.length-1)<arr[0] && arr[0]>=arr[cfg.total-1]){
						// 超出
						// if(i == 0){	//是末位时
						var n = (arr[j]-oppris.length+1);	
						if(n){
							this.changeDom = true;
							for(var a = cfg.total-1;a>=0;a--){									
								arr[a] = arr[a]-n;							
							}	
						}							
						// }
						
						// alert(n)
						// if(domIndex[0])
						// for(var a = )
					}
				}
				if(i==(oppris.length-1)){
					// alert(j+'--------'+domIndex[j])					
					if((oppris.length-1)<arr[j]){
						// 超出
						if(j == (cfg.total-1)){	//是末位时
							var n = (arr[j]-oppris.length+1);	
							if(n){
								this.changeDom = true;
								for(var a = cfg.total-1;a>=0;a--){									
									arr[a] = arr[a]-n;							
								}	
							}							
						}
						
						// alert(n)
						// if(domIndex[0])
						// for(var a = )
					}
				}
				}catch(e){
					// alert('aa2-----'+$.toJSON(e))
					
				}
				
				var acted = (selCode[j][opt.code] || {}).act || false; // 是否选中
				// alert($.toJSON(opt))
				// var bcolor = this.getColor(opt.sell, opt.preclose);
				var ncolor = this.getColor(opt.nprice, opt.preclose);
				var bcolor = this.getColor(opt.buy, opt.preclose);
				var scolor = this.getColor(opt.sell, opt.preclose);
				// var scolor = this.getColor(opt.sell, opt.preclose);
				//log.log([opt.code, cfg.defcode, acted)]);
				html.push(
						'<td gn="', j, '" class="bg26 ', dealCls, (acted ? ' bg53':''),'" code="', opt.code, '" type="', rise, '" trade="', trade, '" date="', cdate.key, '">', parseFloat(opt.cprice, 10).toFixed(4), '</td>',
						'<td gn="', j, '" ', (acted ? 'class="bg53"':''), '>', cfg.numRatio[j], '</td>',
						'<td gn="', j, '" class="', (ncolor ? ncolor:''), ' ', (acted ? ' bg53':''), '">', parseFloat(opt.nprice, 10).toFixed(4), '</td>',
						'<td gn="', j, '" class="', (bcolor ? bcolor:''), ' ', (acted ? ' bg53':''), '">', parseFloat(opt.buy, 10).toFixed(4), '</td>',
						'<td gn="', j, '" class="', (scolor ? scolor : ''), ' ', (j == cfg.total-1 ? '':'br3'), ' ', (acted ? ' bg53':''), '">', parseFloat(opt.sell, 10).toFixed(4), '</td>');
			}
			html.push('</tr>');
		}
		$tby.html(html.join(''));
		try{
			if(this.changeDom){
				// if(cBool){
				// }else{
					// if(Global.selCode[Global.code+'_'+this.strategyid]){
						// selCode = Global.selCode[Global.code+'_'+this.strategyid+'_'+this.sltName];
					// }else{
						Global.selCode[Global.code+'_'+this.strategyid] = "";
						Global.selCode[Global.code+'_'+this.strategyid] = arr;
						
					// }
				// }
			}
		}catch(e){
			// alert('aa3------------'+$.toJSON(e))
		}
		// alert($.toJSON(domIndex))
		if(nMap){
			var dom = $(this.baseCls).find('.strategies tbody');
			// alert(oppris.length)
			// alert()
			var str = cBool?(this.changeDom?'selCode':'selCode0'):'selCode';
			// alert(str)
			// alert(str+'---'+$.toJSON(Global['selCode0'][Global.code+'_'+this.strategyid]))
			var i = 0;
			// alert($.toJSON(Global.selCode[Global.code+'_'+this.strategyid])+'----'+$.toJSON(Global[str][Global.code+'_'+this.strategyid]))
			$.each(Global[str][Global.code+'_'+this.strategyid], function(k,v){
				me.changeDom = "";
			// alert(k+'----'+v)
				var num = dom.find('tr').length-1;
				// alert(v+'--------num-----------'+num)
				if(v>num){
					dom.find('tr').eq(0).find('td').eq(k*5).click();
				}else{
					dom.find('tr').eq(v).find('td').eq(k*5).click();
				}
			})
				
			
		}
		}catch(e){
			// alert('aa4-----------'+$.toJSON(e))
		}
	},
	// 显示错误信息
	showError: function(str){
		log.log(str);
		$('.loading').show();
		$('.ercon').html(str);
		$('.errortip').show();
		
		setTimeout(function(){
			// 鼠标单击 隐藏错误提示
			$(document).on('click', function(e) {
				$(document).off('click');
				$('.loading').hide();
			});
		}, 100);
	}
});