/**
 * 标的UI
 * @author: 卢海宁<luhaining@myhexin.com>
 * @create: 2014-05-08
 */
var Symbol = Panel.extend({
	// 期权Panel对象
	option: null,
	// 标的选择器
	symbolCls: null,
	// 显示或隐藏图表按钮选择器
	toggleCls: null,
	// 期权UI对象
	_option: null,
	/*
	 * 渲染标的
	 * @param symbols Array 接口返回的
	 */
	renderSymbol: function(ss){
		if(ss.length == 0){
			return;
		}
		var html = [];
		for(var i=0; i<ss.length; i++){
			var item = ss[i];
			html.push('<option value="', item.code, '" market="', item.market, '">', item.name, '&nbsp;', item.code,  '</option>');
		}
		$(this.baseCls).find('select').html(html.join('')).trigger('change');
	},
	
	_bindEvent: function(){
		var me = this;
		// 切换标的
		$(this.baseCls).on('change', this.symbolCls, function(e) {		
			$('.amount').val(1);
			var idx = this.selectedIndex,
				code = this.options[idx].value,
				market = this.options[idx].getAttribute('market');
			
			Global.code = code;//0317add
			
			// 获取昨收最新涨跌
			// alert(code+'-----------'+market)
			var xml = thsOption.getTrgateInfo({ // 已加载过的code将直接返回结果
				code: code,
				market: market,
				func: function(xml){
				// alert('badk-=---------'+xml)
					me.trgateCallback(xml);
				}
			});
			// alert(xml)
			if(Global.debug){
				// xml = '<target_param>' +
					// '<target market="17" code="600000" nprice="9.70" rise="0.29" gains="0.29%"/>' +
				// '</target_param>';
			}
			if(xml){
				me.trgateCallback(xml);
			}
		});
		// 收起或展开图表
		$(this.baseCls).on('click', this.toggleCls, function(e) {
			thsOption.switchWndSize(!($(this).toggleClass('hide').hasClass('hide')));
		});
	},
	
	_request: function(){
		var me = this;
		// 获取标的代码
		// var xml = thsOption.getInitParam();
		//log.log('getInitParam:' + (xml || '无缓存！'));
		// if(Global.debug){
			// xml = '<target_param>' +
					// '<item market="17" code="600000" name="浦发银行"/>' +
					// '<item market="17" code="600104" name="上汽集团"/>' +
					// '<item market="17" code="601238" name="广汽集团"/>' +
					// '<item market="17" code="603008" name="白云机场"/>' +
				// '</target_param>';
		// }
		// var data = $.xml2json(xml);
		// this.renderSymbol([].concat(data.item || []));
		
		var initdataready = thsOption.getInitDataReady({
			func:function(initdataready){
				// alert(initdataready)
				me.getInitCallback(initdataready);
			}
		});
	},
	getInitCallback: function(initdataready){
		// alert(initdataready)
		var num = initdataready.split('=')[1];
		var that = this;
		
		if (num==1)
		{
			// $('.boxtable').unbind();
			var xml = thsOption.getInitParam();
			// alert(xml)
			var data = $.xml2json(xml);
			this.renderSymbol([].concat(data.item || []));
		} 
	},
	/*
	 * 获取昨收最新涨跌
	 * @param xml String
	 *	<target_param>
	 *		// 市场 代码 最新 涨跌 涨幅 昨收价
	 *		<target market="17" code="600000" nprice="9.70" rise="0.29" gains="0.29%"/>
	 *	</target_param>
	 */
	trgateCallback: function(xml){
		var data = $.xml2json(xml).target || {};
		log.log(data);
		var $base = $(this.baseCls);
		var num = 2;
		num = (data.market == 20) ? 3 : 2;//市场号为20则是3为小数
		$base.find('.now').text(parseFloat(data.nprice, 10).toFixed(2));
		$base.find('.val').text(parseFloat(data.rise, 10).toFixed(num));
		$base.find('.pos').text(parseFloat(data.gains, 10).toFixed(2) + '%');
		if(data.rise > 0){
			// $base.find('.now').attr('class', 'now red');
			$base.find('.val').attr('class', 'val red');
			$base.find('.pos').attr('class', 'pos red');
		}else if(data.rise < 0){
			// $base.find('.now').attr('class', 'now green');
			$base.find('.val').attr('class', 'val green');
			$base.find('.pos').attr('class', 'pos green');
		}
		if(this._option){
			// if(this._option.code && this._option.code==data.code){
			
			// }else{
				// 重绘option
				data.now = data.nprice;
				this._option.changeCode(data);
			// }
		}else{
			// 渲染期权
			this._option = new Option({
				code: data.code,
				market: data.market,
				now: data.nprice,		// 现价
				rise: data.rise,		// 涨跌
				gains: data.gains,		// 涨幅
				baseCls: '.body',		// 涨幅
				amountCls: '.amount',	// 份数
				orderCls: '#order'		// 下单
			});
		}
	}
});